require "sketchup"

class Indoor_Lenguaje

def initialize

    @strings =Hash.new;

    self.ParseLangFile

	AF_Indoor.description =GetString(AF_Indoor.description)

  end

def ParseLangFile

	file_rec = Sketchup.find_support_file("Indoor.strings", "plugins//AF_Indoor"+"//resources//"+(Sketchup.read_default("Indoor","Language",Sketchup.get_locale[0,2])))

    if file_rec==nil || file_rec.length==0

      return false

    end

    langFile = File.open(file_rec, "r")

    entryString = ""

    inComment = false

    langFile.each do |line|

      if !line.include?("//")

        if line.include?("/*")

          inComment = true

        end

        if inComment==true

          if line.include?("*/")

            inComment=false

          end

        else

          entryString += line

        end

      end

      if entryString.include?(";")

        entryString.strip!

        keyvalue = entryString.split("\"=\"")

        key = keyvalue[0][(keyvalue[0].index("\"")+1)..(keyvalue[0].length+1)]

		result=keyvalue[1].to_s

		result.gsub!(";", "")

        value = result.gsub("\"", "") 

        @strings[key]=value

        entryString = ""

      end

    end

	langFile.close

    return true

  end

def GetString(key)

    retval = @strings[key]

    if retval!= nil

         retval.chomp!

    else

        retval = key

    end

    return retval

  end

def unchecked(menu, item)

	menu.set_validation_proc(item)  {

		MF_UNCHECKED

	}

end

end

class Indoor_Licencia  

def sacaclave(texto)	

	return '' if(texto==nil || texto=='')

	aleatorio1=texto[0] % modulo

	aleatorio2=texto[texto.length-1] % modulo 

	i=0

	clave=''

	a=(aleatorio2 + modulo).chr

	while i<texto.length do

		a <<(aleatorio1+texto[i] % modulo).chr

		a <<(aleatorio2 + a[2*i+1] % modulo).chr

		i +=1

	end

	jj=0

	i=1

	j=(a.length)/11

	if a.length>10

		while i+j<a.length do

			for ii in 0 ... j 

				jj=jj+a[i-1]

				i+=1

			end

			jj=jj % 10

			jj +=39 if jj>9

			clave=clave+(jj+48).chr

		end	

	end 

	return clave

end

def licencia (grabar)

	usuario		= Sketchup.read_default("Indoor","User","")

	email		= Sketchup.read_default("Indoor","Email","")

	numserie	= Sketchup.read_default("Indoor","Serial","")

	clave		= Sketchup.read_default("Indoor","Key","")

	defaultkey	= Sketchup.read_default("Preferences","ValidDefaultKey","")

	num1=sacaclave(email)

	num2=sacaclave(num1)

	if((num1 != numserie) || (num2 != defaultkey))

		if numserie != ""

			usuario		= ""

			Sketchup.write_default("Indoor","User","")

			email		= ""

			Sketchup.write_default("Indoor","Email","")

			numserie	= ""

			Sketchup.write_default("Indoor","Serial","")

			Sketchup.write_default("Indoor","Key","")

			defaultkey=""

			num1=sacaclave(email)

			num2=sacaclave(num1)

		end

		if (defaultkey.to_i-num2.to_i).abs > 57600 || defaultkey.to_i-num2.to_i < 0

			defaultkey = num2

			grabar=true

		end	

		tiempo_uso = (Time.now - IndoorHoraInicio).to_i

		tiempo_tope = (num2.to_i  + 57600)

		tiempo_actual = defaultkey.to_i

		if tiempo_actual < tiempo_tope

			acumulado= tiempo_actual+tiempo_uso

			acumulado= tiempo_tope if acumulado > tiempo_tope

			Sketchup.write_default("Preferences","ValidDefaultKey", acumulado.to_s) if grabar

			numserie='promo' 

			diff = (tiempo_tope-acumulado)

			seconds = diff % 60

			minutes = (diff / 60) % 60

			hours = diff / 3600

			defaultkey= hours.to_s+':'+minutes.to_s+':'+seconds.to_s	

		else

			numserie = ""

			defaultkey=""

		end	

	end

	return [usuario,email,numserie,clave,defaultkey]

end

end

class Indoor_ObservadorApp < Sketchup::AppObserver

def onNewModel(model)

	model.tools.add_observer(Indoor_ObservadorTools.new)

end

def onOpenModel(model)

	model.tools.add_observer(Indoor_ObservadorTools.new)

end

def onQuit()

	IndoorLicencia.licencia(true)

end

end

   

class Indoor_ObservadorTools < Sketchup::ToolsObserver

def onActiveToolChanged(tools, tool_name, tool_id)

	Sketchup.active_model.select_tool Indoor_Borrar.new if tool_id == 21019

end

end

class Indoor_Inicio

def datos_licencia(grabar)

	datoslicencia=IndoorLicencia.licencia(grabar)

	@@usuario=datoslicencia[0]

	@@email=datoslicencia[1]

	@@numserie=datoslicencia[2]

	@@clave=datoslicencia[3]

	@@defaultkey=datoslicencia[4]

	@@datoslicencia=[@@usuario,@@email,@@numserie,@@clave,@@defaultkey]

end

def initialize

	if !file_loaded?("Indoor_cmd.rbs")

		datos_licencia(true)

		s=9.1.mm.to_s

		@@coma=s[1].chr

		if(s[1].chr) =='.'

			@@separador_listas=','

		else

			@@separador_listas=';'

		end

		Sketchup.add_observer(Indoor_ObservadorApp.new)

		Sketchup.active_model.tools.add_observer(Indoor_ObservadorTools.new)

		@@murocmd = UI::Command.new("Muro") { Sketchup.active_model.select_tool Indoor_Muro.new }

		#@@murocmd.small_icon =Sketchup.find_support_file "muro.png","plugins/AF_Indoor"

		#@@murocmd.large_icon =Sketchup.find_support_file "muro.png","plugins/AF_Indoor"

		@@murocmd.tooltip = IndoorStrings.GetString("Wall")  

		@@murocmd.status_bar_text =IndoorStrings.GetString("Draw walls from point to point.")

		@@muropcmd = UI::Command.new("Muro paralelo") { Sketchup.active_model.select_tool Indoor_Murop.new }

		#@@muropcmd.small_icon =Sketchup.find_support_file("murop.png","plugins/AF_Indoor")

		#@@muropcmd.large_icon = Sketchup.find_support_file("murop.png","plugins/AF_Indoor")

		@@muropcmd.tooltip = IndoorStrings.GetString("Paralell wall")

		@@muropcmd.status_bar_text = IndoorStrings.GetString("Draw walls parallel to a edge.")

		@@Estiramurocmd = UI::Command.new("Prolongar muro") { Sketchup.active_model.select_tool Indoor_Estiramuro.new }

		#@@Estiramurocmd.small_icon = Sketchup.find_support_file("estirarmuro.png","plugins/AF_Indoor")

		#@@Estiramurocmd.large_icon = Sketchup.find_support_file("estirarmuro.png","plugins/AF_Indoor")

		@@Estiramurocmd.tooltip = IndoorStrings.GetString("Extend wall")

		@@Estiramurocmd.status_bar_text = IndoorStrings.GetString("Extend / shorten walls.")

		@@puertacmd = UI::Command.new("Puerta") { Sketchup.active_model.select_tool Indoor_Puerta.new }

		#@@puertacmd.small_icon = Sketchup.find_support_file("puerta.png","plugins/AF_Indoor")

		#@@puertacmd.large_icon = Sketchup.find_support_file("puerta.png","plugins/AF_Indoor")

		@@puertacmd.tooltip = IndoorStrings.GetString("Door")

		@@puertacmd.status_bar_text = IndoorStrings.GetString("Place doors in walls.")

		@@ventanacmd = UI::Command.new("Ventana") { Sketchup.active_model.select_tool Indoor_Ventana.new }

		#@@ventanacmd.small_icon = Sketchup.find_support_file("ventana.png","plugins/AF_Indoor")

		#@@ventanacmd.large_icon = Sketchup.find_support_file("ventana.png","plugins/AF_Indoor")

		@@ventanacmd.tooltip = IndoorStrings.GetString("Window")

		@@ventanacmd.status_bar_text = IndoorStrings.GetString("Place windows in walls.")

		@@armariocmd = UI::Command.new("Armario") { Sketchup.active_model.select_tool Indoor_Armario.new }

		#@@armariocmd.small_icon = Sketchup.find_support_file("armario.png","plugins/AF_Indoor")

		#@@armariocmd.large_icon = Sketchup.find_support_file("armario.png","plugins/AF_Indoor")

		@@armariocmd.tooltip = IndoorStrings.GetString("Wardrobe")

		@@armariocmd.status_bar_text = IndoorStrings.GetString("Place wardrobes in walls.")

		@@escaleracmd = UI::Command.new("Escalera") { Sketchup.active_model.select_tool Indoor_Escalera.new }

		#@@escaleracmd.small_icon = Sketchup.find_support_file("escalera.png","plugins/AF_Indoor")

		#@@escaleracmd.large_icon = Sketchup.find_support_file("escalera.png","plugins/AF_Indoor")

		@@escaleracmd.tooltip = IndoorStrings.GetString("Stair")

		@@escaleracmd.status_bar_text = IndoorStrings.GetString("Draw stairs from point to point or by path.")

		@@cotacontinuacmd = UI::Command.new("Acotado continuo") { Sketchup.active_model.select_tool Indoor_CotaContinua.new }

		#@@cotacontinuacmd.small_icon =  Sketchup.find_support_file("cotacontinua.png","plugins/AF_Indoor")

		#@@cotacontinuacmd.large_icon = Sketchup.find_support_file("cotacontinua.png","plugins/AF_Indoor")

		@@cotacontinuacmd.tooltip = IndoorStrings.GetString("Continuous dimension")

		@@cotacontinuacmd.status_bar_text = IndoorStrings.GetString("Continuous interior dimensions between two points.")

		@@preferenciascmd = UI::Command.new("Preferencias") { Sketchup.active_model.select_tool Indoor_Preferencias.new }

		#@@preferenciascmd.small_icon = Sketchup.find_support_file("preferencias.png","plugins/AF_Indoor")

		#@@preferenciascmd.large_icon = Sketchup.find_support_file("preferencias.png","plugins/AF_Indoor")

		@@preferenciascmd.tooltip = IndoorStrings.GetString("Options")

		@@preferenciascmd.status_bar_text = IndoorStrings.GetString("Select language")	

		@@tresdcmd = UI::Command.new("Convertir en 3D") { Sketchup.active_model.select_tool Indoor_TresDimensiones.new }

		#@@tresdcmd.small_icon = Sketchup.find_support_file("3d.png","plugins/AF_Indoor")

		#@@tresdcmd.large_icon = Sketchup.find_support_file("3d.png","plugins/AF_Indoor")

		@@tresdcmd.tooltip = IndoorStrings.GetString("Convert to 3D")	

		@@tresdcmd.status_bar_text = IndoorStrings.GetString("Transforms the 2D model into a 3D model with height defined.")

		#barraIndoor = UI::Toolbar.new (IndoorStrings.GetString("Indoor"))

		@@murocursor_id = nil

		@@muropcursor_id = nil

		@@estiramurocursor_id = nil

		murocursor_path = Sketchup.find_support_file("cursormuro.png", "Plugins/AF_Indoor/icons")

		muropcursor_path = Sketchup.find_support_file("cursormurop.png", "Plugins/AF_Indoor/icons")

		estiramurocursor_path = Sketchup.find_support_file("cursorestirarmuro.png", "Plugins/AF_Indoor/icons")

		escaleracursor_path = Sketchup.find_support_file("cursorescalera.png", "Plugins/AF_Indoor/icons")

		if Sketchup.version_number <=8000999

			borrarcursor_path = Sketchup.find_support_file("cursorborrar.png", "Plugins/AF_Indoor/icons")

			@@borrarcursor_id = UI.create_cursor(borrarcursor_path, 5,21) if borrarcursor_path 

		else

			borrarcursor_path = Sketchup.find_support_file("cursorborrar2013.png", "Plugins/AF_Indoor/icons")

			@@borrarcursor_id = UI.create_cursor(borrarcursor_path, 7,23) if borrarcursor_path 

		end

		borrarcursorIndoor_path = Sketchup.find_support_file("cursorborrarIndoor.png", "Plugins/AF_Indoor/icons")

		@@murocursor_id = UI.create_cursor(murocursor_path, 4,28) if murocursor_path 

		@@muropcursor_id = UI.create_cursor(muropcursor_path, 6,27) if muropcursor_path 

		@@estiramurocursor_id = UI.create_cursor(estiramurocursor_path, 4,28) if estiramurocursor_path 

		@@escaleracursor_id = UI.create_cursor(escaleracursor_path, 4,28) if escaleracursor_path 

		@@borrarcursorIndoor_id = UI.create_cursor(borrarcursorIndoor_path, 5,21) if borrarcursorIndoor_path 

		#barraIndoor = barraIndoor.add_item @@murocmd

		#barraIndoor = barraIndoor.add_item @@muropcmd

		#barraIndoor = barraIndoor.add_item @@Estiramurocmd

		#barraIndoor = barraIndoor.add_item @@puertacmd

		#barraIndoor = barraIndoor.add_item @@ventanacmd

		#barraIndoor = barraIndoor.add_item @@armariocmd

		#barraIndoor = barraIndoor.add_item @@escaleracmd

		#barraIndoor = barraIndoor.add_item @@cotacontinuacmd

		#barraIndoor = barraIndoor.add_item @@tresdcmd

		#barraIndoor = barraIndoor.add_item @@preferenciascmd

		#barraIndoor.show

		#add_separator_to_menu("Plugins")

		#menu = UI.menu("Plugins").add_submenu(IndoorStrings.GetString("Indoor"))

		#item=menu.add_item(IndoorStrings.GetString("Wall")) {Sketchup.active_model.select_tool Indoor_Muro.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Paralell wall")) {Sketchup.active_model.select_tool Indoor_Murop.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Extend wall")) {Sketchup.active_model.select_tool Indoor_Estiramuro.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Door")) {Sketchup.active_model.select_tool Indoor_Puerta.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Window")) {Sketchup.active_model.select_tool Indoor_Ventana.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Wardrobe")) {Sketchup.active_model.select_tool Indoor_Armario.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Stair")) {Sketchup.active_model.select_tool Indoor_Escalera.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Continuous dimension")) {Sketchup.active_model.select_tool Indoor_CotaContinua.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Convert to 3D")) {Sketchup.active_model.select_tool Indoor_TresDimensiones.new}

		#IndoorStrings.unchecked(menu,item)

		#item=menu.add_item(IndoorStrings.GetString("Select language")) { Sketchup.active_model.select_tool Indoor_Preferencias.new }

		@@hv = [1,0]

		@@muro_width  = 0.25.m

		@@muro_gruesos = [0.07,0.10,0.15,0.25,0.40,0.50]

		@@muro_cara = 0

		@@muro_inc = true

		@@forzar_carpinteria=false

		@@puerta_ancho_marco = 0.04.m

		@@puerta_hoja1 = 0.72.m

		@@puerta_hoja2 = '0'.to_l.to_s 

		@@puerta_grueso_marco = 0.12.m

		@@puerta_grueso_hoja = 0.04.m

		@@puerta_hueco = 0

		@@puerta_dintel = 2.1.m

		@@puerta_alineacion=0.0

		@@puerta_hojas = [0.60,0.625,0.70,0.725,0.80,0.825,0.90]

		@@ventana_ancho = 1.20.m

		@@ventana_hojas = 2

		@@ventana_ancho_marco = 0.025.m

		@@ventana_grueso = 0.06.m

		@@ventana_hueco = 0

		@@ventana_hojamax = 1.0.m

		@@ventana_frontal_alfeizar = 0.03.m

		@@ventana_lateral_alfeizar = 0.00.m

		@@ventana_alto = 1.20.m

		@@ventana_alfeizar = 1.0.m

		@@ventana_alineacion = 0.0

		@@armario_ancho = 1.0.m

		@@armario_hoja1 = 0.45.m

		@@armario_ancho_marco = 0.05.m

		@@armario_grueso_marco = 0.05.m

		@@armario_grueso_hoja = 0.025.m

		@@armario_umbral = 0.07.m

		@@armario_dintel = 2.40.m

		@@armario_hojas = 2

		@@escalera_width = 1.0.m

		@@escalera_height = 3.3.m

		@@escalera_cara = 0

		@@escalera_inc = true

		@@escalera_huella = 0.30.m

		@@escalera_huellamin = 0.27.m

		@@escalera_tabica = 0.18.m

		@@escalera_tabicamax= 0.20.m

		@@escalera_slope= 0.63.m

		@@cota_minima = 0.25.m

		@@altura_planta = 3.00.m

		@@crear_grupo = false

		@@color_lineas =  "<Ninguno>"

		@@color_superficies =  "<Ninguno>"

		@@color_seleccion =  "<Ninguno>"

		@@veces_que_entra = -1

		file_loaded("Indoor_cmd.rbs")

	end	

end

end

class Indoor_Base < Indoor_Inicio

def a_longitud(valor)

	valor=con_coma(valor.to_s,nil)

	begin

		numero=valor.to_l

	rescue	

		numero = 0

	end

	return(numero)

end	

def a_float

	valor = con_punto(valor.to_s)

	begin

		numero=valor.to_f

	rescue

		numero=0

	end

	return(numero)

end	

def activate

	Sketchup.active_model.active_view.invalidate

	menu

end	

def ancho_carpinteria(carp)

	if carp.definition.name[0,12].upcase == "Indoor_PUERTA"

		ancho =(carp.get_attribute "dynamic_attributes", "a01hoja1",(carp.definition.get_attribute "dynamic_attributes", "a01hoja1", 0)).to_f.to_l+

				(carp.get_attribute "dynamic_attributes", "a01hoja2",(carp.definition.get_attribute "dynamic_attributes", "a01hoja2", 0)).to_f.to_l+	

				2*(carp.get_attribute "dynamic_attributes", "anchomarco",(carp.definition.get_attribute "dynamic_attributes", "anchomarco", 0)).to_f.to_l

	else

		ancho =(carp.get_attribute "dynamic_attributes", "a01ancho",(carp.definition.get_attribute "dynamic_attributes", "a01ancho", 0)).to_f.to_l

	end

	return ancho

end	

def angulo_recta(p1,p2)

	return nil if p1==p2

	if p1[0] == p2[0]

		if p1[1] < p2[1]

			return Math::PI/2

		else

			return Math::PI*3/2

		end	

	elsif p1[1] == p2[1]

		if p1[0] < p2[0]

			return 0.0

		else	

			return Math::PI

		end	

	else

		result = Math::atan((p2[1]-p1[1])/(p2[0]-p1[0]))

		result += Math::PI if p1[0] > p2[0] 

		result += Math::PI*2 if result < 0.0 

		return result

	end	

end

def borra_auxiliares

	if !@cl1.deleted?

		Sketchup.active_model.active_entities.erase_entities [@cl1, @cl2]

	end if @cl1	

end

def borra_carpinteria(carp)

	return false if !es_carpinteria(carp)

	ptos = muro_carpinteria(carp)

	Sketchup.active_model.active_entities.erase_entities carp

	mocheta1 = Sketchup.active_model.active_entities.add_line ptos[0], ptos[1]

	mocheta2 = Sketchup.active_model.active_entities.add_line ptos[2], ptos[3]

	ptos = tramo_comun(edge_extremos(mocheta1),edge_extremos( mocheta2))

	ptos.push(ptos[1].project_to_line(mocheta2.line))

	ptos.push(ptos[0].project_to_line(mocheta2.line))

	face = Sketchup.active_model.active_entities.add_face ptos

	face.edges.each do |e|

		pon_color(e, mocheta1.material)

	end	

	borra_coplanarias(face.edges)

end

def borra_coplanarias(caras)

	selborrar = []

	caras.each do |e|

		if !e.deleted? 

			if(e.faces.size == 2) 

				selborrar.push e if(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999) 

			end

		end	

	end

	if 	selborrar != []

		model = selborrar[0].model

		model.active_entities.erase_entities selborrar

	end	

end 

def busca_cara(x, y, view)

	ph = view.pick_helper

	ph.do_pick x, y

	cara=ph.picked_edge

	if cara

		return cara if cara.parent.entities == Sketchup.active_model.active_entities

	end	

	return nil

end

def busca_carpinteria(x, y, view)

	ph = view.pick_helper

	ph.do_pick x, y

	elemento=ph.best_picked

	if elemento.is_a?(Sketchup::ComponentInstance)

		if es_carpinteria(elemento)

			return elemento if elemento.parent.entities == Sketchup.active_model.active_entities

		end	

	end if elemento	

	return nil

end

def reset

 end

 

def CambiaIdioma(key)

    return IndoorStrings.GetString(key)

end

def crea_auxiliares(pt)

	return if pt==[]

	@cl1 = Sketchup.active_model.active_entities.add_cline pt, [0,0]

	@cl2 = Sketchup.active_model.active_entities.add_cline pt, [0,0]

	@cl1.direction = [@@hv[0], @@hv[1]]

	@cl2.direction = [-@@hv[1], @@hv[0]]

	@cl1.stipple = @cl2.stipple = "."

	@cl1.start = @cl1.end = @cl2.start = @cl2.end = nil

end

def con_coma(text,sep)

	if !sep

		sep='.'

		sep=@@coma if @@separador_listas==';'

	end	

	texto=''

	for i in 0 .. text.length-1

		if text[i].chr=='.' || text[i].chr==@@coma

			texto=texto+sep

		else

			texto=texto+text[i].chr

		end	

	end

	return texto

end

def draw(view)

	textoevaluacion(view)

end	

def escalera_3d(escalera)

	altura=escalera.get_attribute "escalera","2d"

	return if !altura

	cota=nil

	temp=[]

	escalera.entities.each do |p|

		temp.push p if p.get_attribute "escalera","escalon"

	end

	tabica=altura/temp.size  

	temp.each do |p|

		if !p.deleted?

			peld=p.get_attribute "escalera","escalon"

			cota=p.edges[0].start.position.z if !cota

			extrusiona(p,peld) 

		end

	end

	selborrar = []

	escalera.entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			if(e.faces.size == 3)

				if e.start.position.z == e.end.position.z and e.faces[0].normal.z+e.faces[1].normal.z+e.faces[2].normal.z>1.999999

					selborrar.push e

				end

			end

		end

	end

	escalera.entities.erase_entities selborrar if selborrar != []

	selborrar=[]

	escalera.entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			if vertical(e)

				if e.length>tabica

					selborrar.push e

				end	

			end

		end

	end

	escalera.entities.erase_entities selborrar if selborrar!=[]

	selborrar=[]

	escalera.entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			if e.start.position.z==cota && e.end.position.z==cota && e.faces.size==1

				selborrar.push e

			end

		end

	end	

	escalera.entities.erase_entities selborrar

	selborrar=[]

	escalera.entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			if e.start.position.z==cota && e.faces.size==1 && vertical(e)

				borrar=false

				escalera.entities.each do |f|

					if f.is_a?(Sketchup::Edge)

						borrar=true if f.start.position==e.end.position && vertical(f)

					end	

				end

				selborrar.push e if borrar 

			end

		end

	end	

	escalera.entities.erase_entities selborrar

	selborrar=[]

	escalera.entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			if e.faces.size==0

				selborrar.push e

			end

		end

	end	

	escalera.entities.erase_entities selborrar

	escalera.set_attribute "escalera","3d",altura

	escalera.set_attribute "escalera","2d",false

end

def nolicencia(inhabilitar)

	return false if @@numserie !="" 

	@@veces_que_entra +=1

	@@veces_que_entra = 0 if inhabilitar

	IndoorLicencia.informacion(@@datoslicencia) if (@@veces_que_entra % 5 == 0)

	Sketchup.active_model.select_tool nil if inhabilitar	

	return true

end	

def textoevaluacion(view)

	texto=CambiaIdioma(" ")####="TC-室内助手/www.xujingfu.top/啊福"

	if @@numserie =='promo'

		x=view.corner(0)[0]

		y=view.corner(0)[1]

	else

		texto=texto+""

		x=view.corner(2)[0]

		y=view.corner(2)[1]-30

	end	

	view.draw_text([x+2,y+12],texto)

end

def deactivate(view)

	view.invalidate

end	

def vertical(edge)

	if edge.start.position.x==edge.end.position.x && edge.start.position.y==edge.end.position.y

		return true

	else

		return false

	end	

end

def extrusiona(face, h)

	face.reverse! if face.normal.z < 0

	face.pushpull h, true

end

def long_valida(valor)

	return nil if !valor

	value = valor.to_l

	return value if value

	begin

        value=con_coma(valor,nil).to_l

    rescue

        UI.beep

        value = nil

        Sketchup::set_status_text "", SB_VCB_VALUE

    end

	return value

end

def muestra_valor(t)

	Sketchup::set_status_text t, SB_VCB_VALUE

end

def mocheta_real(carp)

	ancho=ancho_carpinteria(carp)

	ptos = []

	extremo1 = [0, 0, 0].transform! carp.transformation

	extremo2 = [ancho, 0, 0].transform! carp.transformation

	linea = Sketchup.active_model.active_entities.add_line extremo1, extremo2

	linea.vertices.each do |ver|

		mocheta = nil

		ver.edges.each do |moch|

			if mismo_grupo(moch, carp)

				if perpendicular(linea, moch)

					ptos.push(moch.start.position) if !mocheta 

					mocheta = moch

				end

			end	

		end

		ptos.push(mocheta.end.position) if mocheta

	end

	Sketchup.active_model.active_entities.erase_entities linea

	return ptos

end

def mocheta_puntos(pt1,pt2)

	Sketchup.active_model.active_entities.each do |e|

		if e.is_a?(Sketchup::Edge)	

			return e if (e.start.position == pt1 && e.end.position == pt2) || (e.end.position == pt1 && e.start.position == pt2) 

		end if e.valid?

	end	

	return nil

end

def muro_carpinteria(carp)

	ancho = ancho_carpinteria(carp)

	ptos = []

	ptos.push(Geom::Point3d.new([0,0,0].transform!(carp.transformation)))

	ptos.push(Geom::Point3d.new([0,-(carp.get_attribute "dynamic_attributes", "mocheta",(carp.definition.get_attribute "dynamic_attributes", "mocheta", 0)).to_f.to_l,0].transform!(carp.transformation)))

	ptos.push(Geom::Point3d.new([ancho,-(carp.get_attribute "dynamic_attributes", "mocheta",(carp.definition.get_attribute "dynamic_attributes", "mocheta", 0)).to_f.to_l, 0].transform!(carp.transformation)))

	ptos.push(Geom::Point3d.new([ancho, 0, 0].transform!(carp.transformation)))

	return ptos

end

def perpendicular(linea1, linea2)

	return true	if(linea1.start.position-linea1.end.position).perpendicular?(linea2.start.position-linea2.end.position)

end

def angulo_inverso(angulo)

	if angulo < Math::PI

		return(angulo + Math::PI) 

	else 

		return(angulo - Math::PI)

	end

end	

def punto_en_segmento(pt, pt1, pt2)

	return false if !pt || !pt1 || !pt2

	return true if(pt-pt1).length+(pt-pt2).length <(pt1-pt2).length+0.0001

	return true if(pt-pt1).length < 0.0001

	return true if(pt-pt2).length < 0.0001

	return false

end

def punto_a_distancia(pt1, pt2, dist)

	return pt1 if dist==0

	@long =(pt1 - pt2).length

	return nil if @long == 0.0 

	return Geom.linear_combination(dist/@long, pt2, 1-(dist/@long), pt1)

end

def punto_medio(pt1, pt2)

	return Geom.linear_combination(0.5, pt1, 0.5, pt2)

end

def otra_cara_perp(cara1,pt)

	return nil if !cara1

	return nil if cara1.deleted?

	return nil if cara1.faces.size != 1

	pt = pt.project_to_line cara1.line if !punto_en_segmento(pt, cara1.start.position, cara1.end.position)

	gru = 100000.0

	resultado = nil

	vec1 = cara1.start.position - cara1.end.position

	face = cara1.faces[0]

	face.edges.each do |e|

		if cara1 != e

			vec2 = e.start.position - e.end.position

			if vec1.parallel? vec2

				pt1 = pt.project_to_line e.line

				vec3 = pt - pt1

				if punto_en_segmento(pt1, e.start.position, e.end.position)

					if face.classify_point(punto_medio(pt,pt1)) == Sketchup::Face::PointInside 

						ptos=tramo_comun(edge_extremos(cara1),edge_extremos(e))

						if vec3.length < gru

							gru = vec3.length

							resultado = e

							@ptperp = pt1

						end	if ptos[0] != ptos[1]

					end

				end	

			end

		end	

	end

	return resultado

end	

def edge_extremos(e)

	return([e.start.position,e.end.position])

end

def tramo_comun(l1, l2)

	if (l1[0]-l1[1]).length >0 && (l2[0]-l2[1]).length > 0

		pt1 = l1[0]

		pt2 = l2[0].project_to_line(l1) 

		pt3 = l2[1].project_to_line(l1)

		pt4 = l1[1]

		if(pt2 == pt4) or(pt3 == pt1)

			ptini = pt3

			pt3 = pt2

			pt2 = ptini

		end

		if punto_en_segmento(pt1 , pt2, pt3)

			ptini = pt1 

		elsif punto_en_segmento(pt2 , pt1, pt4)	

			ptini = pt2 	

		elsif punto_en_segmento(pt3 , pt1, pt4)

			ptini = pt3

		elsif

			punto_en_segmento(pt4 , pt2, pt3)

			ptini = pt4

		else

			return []

		end	

		if punto_en_segmento(pt4 , pt2, pt3)

			ptfin = pt4 

		elsif punto_en_segmento(pt3 , pt1, pt4)	

			ptfin = pt3 	

		else

			ptfin = pt2

		end	

		return[ptini, ptfin]

	end

	return []

end

def inicioundo(comando)

	Sketchup.active_model.start_operation comando, false, true, false

end

def finalundo

	Sketchup.active_model.start_operation "", false, false, false

end

 def selecciona_entidades(model)

	if model==Sketchup.active_model

		return model.entities

	else

		return model.entities

	end	

 

 end

 

def borra_coplanarias_3d(model)

	entidades=selecciona_entidades(model)

	selborrar = []

	entidades.each do |e|

		if e.is_a?(Sketchup::Edge)

			if(e.faces.size == 3)

				if e.start.position.z == e.end.position.z and e.faces[0].normal.z+e.faces[1].normal.z+e.faces[2].normal.z>1.999999

					selborrar.push e

				end

			end

		end

	end

	entidades.erase_entities selborrar if selborrar != []

	selborrar = []

	entidades=selecciona_entidades(model)

	entidades.each do |e|

		if e.is_a?(Sketchup::Edge)

			if(e.faces.size == 2)

				selborrar.push e if(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999) 

			end

		end

	end

	entidades.erase_entities selborrar if selborrar != []  

end

 

def borra_muro(x, y, view, modoundo)

	cara1 = busca_cara(x, y, view)

	if cara1

		cara2 = otra_cara_perp(cara1,(view.inputpoint x,y).position)

		if cara2

			Sketchup.active_model.selection.remove(cara1, cara2)

			ptos = tramo_comun(edge_extremos(cara1), edge_extremos(cara2))

			pt1 = ptos[0]

			pt2 = pt1.project_to_line(cara2.line)

			pt3 = ptos[1]

			pt4 = pt3.project_to_line(cara2.line) 

			lado =(pt1 - (view.inputpoint(x,y)).position).length - (pt3 - (view.inputpoint(x,y)).position).length	

			extremos =[]

			extremos.push(Sketchup.active_model.active_entities.add_line(pt1, pt2))

			extremos.push(Sketchup.active_model.active_entities.add_line(pt3, pt4))

			borrar = Sketchup.active_model.active_entities.add_line(pt1, pt3)

			Sketchup.active_model.active_entities.erase_entities(borrar)

			borrar = Sketchup.active_model.active_entities.add_line(pt2, pt4)

			Sketchup.active_model.active_entities.erase_entities(borrar)

			result = [pt1, pt2, pt3, pt4] 

			extremo1=false

			extremos.each do |e|

				if !e.deleted?

					if e.faces.size == 0

						Sketchup.active_model.active_entities.erase_entities(e)

					else	

						pt = ptt = linea1 = linea2 = vert1 = vert2 = vert3 = linea3 = nil

						e.vertices.each do |vert|

							vert.edges.each do |lin|

								if lin != e  && lin.faces.size == 1

									if e.faces.first == lin.faces.first

										if(perpendicular(e,lin) && !linea1) || linea2

											linea1 = lin

											vert1 = vert.position

											vert3 = lin.other_vertex vert

											vert3.edges.each do |lin2|

												if lin2.faces.size == 1

													linea3 = lin2 if lin2 != lin

												end

											end

										else

											linea2 = lin

											vert2 = vert.position

										end

									end	

								end

							end

						end

						if !perpendicular(e,linea2)

							if otra_cara_perp(linea2,vert2) == linea3

								if extremo1

									result[2] = vert2

									result[3] = vert3.position

								else

									result[0] = vert2

									result[1] = vert3.position

								end				

								if !modoundo &&((lado <= 0 && extremo1) ||(lado > 0 && !extremo1))

									Sketchup.active_model.active_entities.add_line(vert2, vert3)

									Sketchup.active_model.active_entities.erase_entities(linea1, e)

								else

									pon_color((Sketchup.active_model.active_entities.add_line(vert2, @ptperp)),linea1.material)

									linea3 = Sketchup.active_model.active_entities.add_line(vert3, @ptperp)

									pon_color(linea3,linea1.material)

									Sketchup.active_model.active_entities.erase_entities(linea1, e, linea3)

								end

							else

								ptt = Geom.intersect_line_line(linea3.line, linea2.line)

								pt = Geom.intersect_line_line(linea1.line, linea2.line)

								if pt

									if extremo1

										result[2] = vert2

										result[3] = pt

									else

										result[0] = vert2

										result[1] = pt

									end	

									if ptt &&(ptt-vert2).length <(pt-vert2).length

										face = Sketchup.active_model.active_entities.add_face ptt, vert3.position, vert1, vert2

									else	

										face = Sketchup.active_model.active_entities.add_face pt, vert1, vert2

									end

									caras = face.edges

									Sketchup.active_model.active_entities.erase_entities(e)

									caras.each do |l|

										if !l.deleted?

											Sketchup.active_model.active_entities.erase_entities l if l.faces.size != 1

										end	

									end if caras

								end	

							end

						end

					end	

				end

				extremo1 = true if !extremo1	

			end	

			view.invalidate

			@borrando = false

			if !(result[0]-result[2]).parallel?(result[1]-result[3]) 

				paso = result[2]

				result[2] = result[3]

				result[3] = paso

			end

			return result

		end

	end

	return false

end

def mismo_grupo(x, y)

	return true if x.parent == y.parent

	return false

end

 

def interseccion_real(pt1, pt2, pt3, pt4)

	pt1=Geom::Point3d.new(pt1)if pt1.class==Array

	pt2=Geom::Point3d.new(pt2)if pt2.class==Array

	pt3=Geom::Point3d.new(pt3)if pt3.class==Array

	pt4=Geom::Point3d.new(pt4)if pt4.class==Array

	return nil if !pt1 || !pt2

	return pt1 if pt1==pt3 || pt1==pt4

	return pt2 if pt2==pt3 || pt2==pt4

	pt = Geom.intersect_line_line([pt1, pt2],[pt3, pt4])

	return pt if punto_en_segmento(pt, pt1, pt2) && punto_en_segmento(pt, pt3, pt4)

	return nil

end 

def interseccion_real_edges(e1,e2)

	pt1=e1.start.position

	pt2=e1.end.position

	pt3=e2.start.position

	pt4=e2.end.position

	return interseccion_real(pt1,pt2,pt3,pt4)

end	

def es_carpinteria(carp)

	return false if carp.definition.name.index('3D') 

	if carp.definition.name[0,12].upcase == "Indoor_PUERTA" || carp.definition.name[0,13].upcase == "Indoor_VENTANA" || carp.definition.name[0,13].upcase == "Indoor_ARMARIO"

		return true

	else

		return false

	end

end

def intermedios(linea,extremos,carpinterias)

	puntos = [] 

	Sketchup.active_model.active_entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			if e.faces.size == 1

				pt = interseccion_real(linea[0], linea[1], e.start.position, e.end.position)

				if extremos ||(pt != linea[0] && pt != linea[1] && pt != puntos.last)

					puntos.push(pt)

				end if pt

			end	

		elsif e.is_a?(Sketchup::ComponentInstance) && carpinterias

			if es_carpinteria(e)

				ptcarp=muro_carpinteria(e)

  				pt = interseccion_real(linea[0], linea[1], ptcarp[0], ptcarp[3])

				if extremos ||(pt != linea[1] && pt != linea[2] && pt != puntos.last)

					puntos.push(pt)

				end if pt

				pt = interseccion_real(linea[0], linea[1], ptcarp[1], ptcarp[2])

				if extremos ||(pt != linea[0] && pt != linea[1] && pt != puntos.last)

					puntos.push(pt)

				end if pt

			end

		end

	end

	return puntos if puntos.size < 2

	i = -1

	result=[]

	ultimadistancia=-1

	while i < puntos.size-1 do

		j = 0

		k = 0

		distancia = 1000000.0

		while j < puntos.size

			if puntos[j] 

				if(linea[0]-puntos[j]).length < distancia

					distancia =(linea[0]-puntos[j]).length

					punto = puntos[j]

					k = j

				end	

			end 

			j += 1

		end

		result.push(punto) if distancia > ultimadistancia

		ultimadistancia=distancia

		puntos[k] = nil

		i += 1

	end	

	return result

end

def onCancel(flag, view)

	reset

	view.lock_inference if( view.inference_locked? )

	view.invalidate

end

def draw(view)

	texto_comando

end	

def onRButtonDown(flags, x, y, view)

	view.invalidate

	menu

end	

def menu	

	reset

end

def pon_cota_lineal(model, pt1, pt2)

	@componente = Sketchup.active_model.definitions.load(Sketchup.find_support_file("Indoor_COTAL.skp","Plugins/AF_Indoor"))

	transform = Geom::Transformation.translation(pt1)

	transform =(Geom::Transformation.scaling(pt1,(pt1-pt2).length,1,1)) * transform 

	transform =(Geom::Transformation.rotation(pt1, [0,0,1], angulo_recta(pt1,pt2))) * transform	

	@instance = model.entities.add_instance(@componente,transform)

	@cota=@instance.explode	

	@cota[0].set_attribute "Indoorcotas", "pt1", pt1

	@cota[0].set_attribute "Indoorcotas", "pt2", pt2

	return @cota

end

def pon_color(entidad,mat)

	if mat =="<Ninguno>"

		mat = nil

	end

	entidad.material=mat

	entidad.back_material = mat if entidad.is_a?(Sketchup::Face)

end

end

class Indoor_Borrar < Indoor_Base

def reset

	@puntos_muro = []

	@carpinterias = []

	@previo=true if Sketchup.active_model.selection.count>0

	Sketchup::set_status_text "", SB_VCB_LABEL

	Sketchup::set_status_text "", SB_VCB_VALUE

	texto = CambiaIdioma("选择要擦除或于多个项目间进行拖动的项目。")

	texto = texto + " " + CambiaIdioma("Shift")+"="+CambiaIdioma("隐藏")

	texto = texto +", Ctrl="

	texto = texto +","

	texto = texto +CambiaIdioma("柔化/平滑")

	texto = texto +""

	texto = texto +""

	texto = texto+CambiaIdioma("")+""

	Sketchup::set_status_text  texto

	@cursor = @@borrarcursor_id if !@cursor

end

def activate

	Sketchup.active_model.active_view.invalidate

	reset

end	

def onSetCursor

	UI.set_cursor(@cursor)

end

def selecciona(x, y, view)

	return if !@borrando

	ph = view.pick_helper

	ph.do_pick x, y

	Sketchup.active_model.selection.clear if @previo

	@previo=false

	@puntos_muro.push [x,y]

	for i in 0 ... ph.count

		e=ph.element_at(i)

		if !ph.leaf_at(i).is_a?(Sketchup::Face)

			@carpinterias.push e if e.is_a?(Sketchup::ComponentInstance)

			Sketchup.active_model.selection.add e

		end

	end	

end

def onMouseMove(flags, x, y, view)

	selecciona(x, y, view)

end

def onLButtonDown(flags, x, y, view)

	@borrando = true

	selecciona(x, y, view)

end

def onLButtonUp(flags, x, y, view)

	@borrando = false

	sel = Sketchup.active_model.selection

	if @pulsado_shift && !@pulsado_ctrl

		inicioundo(CambiaIdioma("Hide"))

		sel.each { |e| e.hidden=true}	

		sel.clear

		finalundo

		return	

	end

	if @pulsado_ctrl && !@pulsado_shift

		inicioundo(CambiaIdioma("Soften edges"))

		sel.each { |e| e.soft=true if e.is_a?(Sketchup::Edge)}

		sel.clear

		finalundo

		return	

	end

	inicioundo(CambiaIdioma("Erase"))	

	if @pulsado_alt

		@puntos_muro.each do |pt|

			borra_muro(pt[0], pt[1], view, true)

		end

		@carpinterias.each do |carp|

			borra_carpinteria(carp) if !carp.deleted?

		end

		reset

	end

	Sketchup.active_model.active_entities.erase_entities sel

	finalundo

end

def onKeyDown(key, rpt, flags, view)

	@pulsado_shift = true if key == CONSTRAIN_MODIFIER_KEY

	@pulsado_ctrl = true if key == COPY_MODIFIER_KEY

	@pulsado_alt = true if key == ALT_MODIFIER_KEY

end

def onKeyUp(key, rpt, flags, view)

	@pulsado_shift = false if key == CONSTRAIN_MODIFIER_KEY

	@pulsado_ctrl = false if key == COPY_MODIFIER_KEY

	@pulsado_alt = false if key == ALT_MODIFIER_KEY

end

def draw(view)

	textoevaluacion(view)

end

end

class Indoor_Muro < Indoor_Base

def initialize

	@ip = Sketchup::InputPoint.new

	@ip1 = Sketchup::InputPoint.new

end

def menu	

	prompts = 	[CambiaIdioma("厚度")	]

		defaults = [	@@muro_width.to_l.to_s

						]

	list = 			[	""

						]

	input = UI.inputbox prompts, defaults, list, CambiaIdioma("墙体")

	if input

		h1 = a_longitud(input[0]).abs

		@@muro_width = h1 if h1>0

		case input[1].to_s

		when CambiaIdioma("Left") 

			@@muro_cara=0.0

		when CambiaIdioma("Center") 

			@@muro_cara=0.5

		when CambiaIdioma("Right")

			@@muro_cara=1.0

		end

		h1 = input[2].to_s.upcase

	else	

		Sketchup.active_model.select_tool nil	

		return

	end	

end

def reset

	borra_auxiliares

	Sketchup.active_model.commit_operation if @primer_punto

	@primer_punto = @pulsado_tab = false

	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []

	@arini = @arfin = @lineai = @linead = @vertice1 = @vertice2 = nil

	Sketchup::set_status_text "", SB_VCB_LABEL

	Sketchup::set_status_text "", SB_VCB_VALUE

	texto_comando

end

def activate

	Sketchup.active_model.active_view.invalidate

	menu

	@comando_en_curso = "Wall"

	reset

end

def texto_comando

	texto = CambiaIdioma("墙体厚度") +"["+ @@muro_width.to_l.to_s+"]."

	if !@primer_punto

		texto = texto+CambiaIdioma("点击起点...")

	else	

		texto= texto+CambiaIdioma("点击下一点...")

	end	

	texto = texto + ", " + CambiaIdioma("TAB=切换参考“左”“中”“右”") + " '-'."

	if @primer_punto

		texto = texto + ""+CambiaIdioma("")+"."

		texto = texto + ""+CambiaIdioma("")+"."

	end	

	Sketchup::set_status_text  texto 

end		

def deactivate(view)

	view.invalidate

	reset

end

def onSetCursor

	UI.set_cursor(@@murocursor_id)

end

def calcula_puntos

	return false if !@primer_punto

	if @comando_en_curso == "Wall"

		if @vertice1 && @vertice2

			vec =(@vertice1.position - @vertice2.position)

			@ptini = @vertice1.position.offset(vec, -@@muro_cara*vec.length)

		end	

	end	

	i = 1

	while i < 5

		if @@muro_cara > 0 then

			vec = @ptini - [@ptini[0] +(@ptfin[1] - @ptini[1]), @ptini[1] - (@ptfin[0] - @ptini[0]),@ptini[2]]

			if vec.length>0

				@pt1 = @ptini.offset(vec, @@muro_cara * @@muro_width)	 

				@pt2 = @ptfin.offset(vec, @@muro_cara * @@muro_width)

			end	

		else

			@pt1 = @ptini	 

			@pt2 = @ptfin	   

		end

		vec = @ptini - [@ptini[0] - (@ptfin[1] - @ptini[1]), @ptini[1] +(@ptfin[0] - @ptini[0]),@ptini[2]]

		if vec.length>0

			@pt3 = @pt1.offset(vec, @@muro_width) if @pt1!=[]

			@pt4 = @pt2.offset(vec, @@muro_width) if @pt2!=[]	  

		end	

		if !@arfin.deleted? 

			pt0 = Geom.intersect_line_line([@pt1, @pt2], @arfin.line) 

			pt1 = Geom.intersect_line_line([@pt3, @pt4], @arfin.line) if @pt4!=[]

			if 	punto_en_segmento(pt0,@arfin.start.position,@arfin.end.position )

				@pt2 = pt0

				@pt4 = pt1

			end	if punto_en_segmento(pt1,@arfin.start.position,@arfin.end.position )

		end if @arfin

		if @lineai && @linead

			@pt1 = pt0 if pt0 = Geom.intersect_line_line([@pt1, @pt2], @lineai)

			@pt3 = pt0 if pt0 = Geom.intersect_line_line([@pt3, @pt4], @linead)

		elsif @arini

			pt0 = Geom.intersect_line_line([@pt1, @pt2], @arini.line)

			pt1 = Geom.intersect_line_line([@pt3, @pt4], @arini.line) if @pt4!=[]

			if 	punto_en_segmento(pt0,@arini.start.position,@arini.end.position )

				@pt1 = pt0 

				@pt3 = pt1 

				return true

			end if punto_en_segmento(pt1,@arini.start.position,@arini.end.position )

			if !@pulsado_tab

				i += 1 

				tabulador 

			end 

		end	

		i = 5 if !@arini || @pulsado_tab

	end

	@pulsado_tab = true

end

 

def onMouseMove(flags, x, y, view)

    return false if( !@ip.pick(view, x, y, @ip1) )

	texto_comando

	view.tooltip = @ip.tooltip

	if !@primer_punto

		view.invalidate if @arini = busca_cara(x, y, view)

    else

		@ptfin = @ip.position

		@ptfin.z=@ptini.z

		vec = @ptini - @ptfin

		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE

		calcula_puntos if vec.length > 0

		@arfin = busca_cara(x, y, view)

	end

	view.invalidate

end

 

def haz_muro

	puntos = intermedios([@pt1,@pt2], false,false).unshift(@pt1)

	pt1 = puntos.last

	puntos = puntos + intermedios([@pt2,@pt4], false,false).unshift(@pt2)

	x = intermedios([@pt4,@pt3], false,false).unshift(@pt4)

	pt2 = @pt3

	pt2 = x[1] if x.size > 1

	puntos = puntos + x

	puntos = puntos + intermedios([@pt3,@pt1], false,false).unshift(@pt3)

	face = Sketchup.active_model.active_entities.add_face puntos 

	pon_color(face,@@color_superficies)

	selborrar = []

	Sketchup.active_model.active_entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			if face.classify_point(punto_medio(e.start.position,e.end.position)) == Sketchup::Face::PointInside

				selborrar.push(e)

			end

		end

	end

	Sketchup.active_model.active_entities.erase_entities selborrar if selborrar != []

	@lineai = [@pt1, @pt2]

	@linead = [@pt3, @pt4]

	linea_ult = Sketchup.active_model.active_entities.add_line @pt2, @pt4

	pon_color(linea_ult,@@color_lineas)

	@vertice1 = linea_ult.start

	@vertice2 = linea_ult.end

	caras = face.edges

	caras.each do |e|

		pon_color(e,@@color_lineas)

	end

	borra_coplanarias(caras)

	@ptini = @ptfin

	if linea_ult.deleted? || @vertice2.deleted? || @vertice1.deleted?

		reset

		return false

	end

	return true

end

def create_muro

	finalundo

	if @lineai && @linead

		vec = @pt1-@vertice1.position

		Sketchup.active_model.active_entities.transform_entities(vec, @vertice1) if vec.length > 0 && !@vertice1.deleted?

		vec = @pt3-@vertice2.position

		Sketchup.active_model.active_entities.transform_entities(vec, @vertice2) if vec.length > 0 && !@vertice2.deleted?

	end

	inicioundo(CambiaIdioma("Wall")) if haz_muro

	@pulsado_tab = false

end

def onLButtonDown(flags, x, y, view)

	borra_auxiliares

	@ip1.pick(view,x,y,@ip)

	if !@primer_punto

		inicioundo(CambiaIdioma("Wall"))

		@ptini = @ip.position

		Sketchup::set_status_text CambiaIdioma("Length"), SB_VCB_LABEL

		@primer_punto = true

	else

		create_muro

		@arini = nil

		@long_usuario = false

	end

	crea_auxiliares(@ptini)

	texto_comando

	view.lock_inference

	view.invalidate

end

def longitud_usuario(valores, view)

	vec = @ptfin - @ptini

	if( vec.length > 0.0 )

		valores.each do |value|

			vec = @ptini - @ptfin if con_coma(value,nil).to_l < 0

			vec.length = value.to_l.abs 

			@ptfin = @ptini.offset(vec)

			@ip1.pick(view, view.screen_coords(@ptfin).x, view.screen_coords(@ptfin).y,@ip) 

			calcula_puntos

			ptperp = @ptini.transform(Geom::Transformation.rotation(@ptfin, [0,0,1], Math::PI/2))

			create_muro

			@arini = nil

			@ptfin = ptperp

			vec = @ptfin - @ptini

		end

	end

end

def onUserText(text, view)

	text=con_coma(text,nil)

	valores = text.split("*")

    value = valores[1].to_i

	if value > 0

		muro_multiplica(value)

		return

	end

	if text[0].chr == '/'

		valores = text.split("/")

		value = valores[1].to_i

		if value >  0

			muro_multiplica(1.0/value)

			return

		end

	end	

	valores = text.split("<")

	if valores[1]

		angulo = valores[1].to_f.degrees

		@@hv = [Math.cos(angulo), Math.sin(angulo)]

		borra_auxiliares

		crea_auxiliares(@ptini) if @primer_punto

		return

	end

	valores = text.split(@@separador_listas)

	value=long_valida(valores[0])

    if value

		if value < 0 then

			@@muro_width = value.abs.to_l

			texto_comando

			calcula_puntos

		else

			borra_auxiliares

			longitud_usuario(valores, view)

			crea_auxiliares(@ptini)

		end

		view.invalidate

		return

	end

end

def draw(view)

 	textoevaluacion(view)

    @ip.draw(view) if( @ip.valid? && @ip.display? )

    if !@arini.deleted?

		view.line_width = 4

		view.drawing_color = "magenta"

		view.draw(GL_LINES, @arini.start.position,@arini.end.position)

	end if @arini

    if !@arfin.deleted?

		view.line_width = 4

		view.drawing_color = "magenta"

		view.draw(GL_LINES , @arfin.start.position,@arfin.end.position)

	end if @arfin

    view.drawing_color = "black"

    view.line_width = 1 

    inference_locked = view.inference_locked?

	view.set_color_from_line(@ip1, @ip) if @primer_punto

	view.line_width = 4 if inference_locked

	if @primer_punto

		view.line_stipple='-.-'

		view.draw(GL_LINE_STRIP, @ptini, @ptfin)

		view.line_stipple=''

		view.draw(GL_LINE_STRIP, @pt2, @pt4) if @pt4!=[]

		view.draw(GL_LINE_STRIP, @pt1, @pt2) if @pt2!=[]

		view.draw(GL_LINE_STRIP, @pt3, @pt4) if @pt4!=[]

		view.draw(GL_LINE_STRIP, @vertice1.position, @pt1) if @vertice1

		view.draw(GL_LINE_STRIP, @vertice2.position, @pt3) if @vertice2

		view.draw(GL_LINE_STRIP, @pt1, @pt3) if !@vertice1 && @pt3!=[]

	end

end

def tabulador

	if @@muro_inc then

		@@muro_cara += 0.5

	elsif

		@@muro_cara -= 0.5

	end	

	@@muro_inc = !@@muro_inc if @@muro_cara != 0.5

end

def onKeyDown(key, rpt, flags, view)

	if(key == 9) ||(key==VK_CONTROL) then

		borra_auxiliares

		tabulador

		calcula_puntos

		crea_auxiliares(@ptini) if @comando_en_curso=="Wall"

		view.invalidate

		@pulsado_tab = true if @primer_punto

	elsif key == 119

		lb = @arfin.line 

		if lb

			@@hv = [lb[1][0],lb[1][1]]

			borra_auxiliares

			crea_auxiliares(@ptini) if @primer_punto

		end

	elsif( key == CONSTRAIN_MODIFIER_KEY && rpt == 1 )

        if( view.inference_locked? )

            view.lock_inference

        elsif !@primer_punto

            view.lock_inference @ip

        elsif

            view.lock_inference @ip, @ip1

		end

	end	

end	

def onKeyUp(key, rpt, flags, view)

	if(key == CONSTRAIN_MODIFIER_KEY && view.inference_locked?)

		view.lock_inference

    end

end

end

class Indoor_Murop < Indoor_Muro

def reset

	@comando_en_curso = "Paralell wall"

	@primer_punto = @pulsado_tab = false

	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []

	@arini = @arfin = @lineai = @linead = @vertice1 = @vertice2 = nil

	Sketchup::set_status_text "", SB_VCB_LABEL

	Sketchup::set_status_text "", SB_VCB_VALUE

	texto_comando

end

def deactivate(view)

	view.invalidate

	@@penultima_dist=@ultima_dist if @ultima_dist

end	

def create_muro

	inicioundo(CambiaIdioma("Paralell wall"))

	@ultp1=@lbase.start.position

	@ultp2=@lbase.end.position

	@ultimo_punto=@primer_punto

	@@penultima_dist=@ultima_dist if @ultima_dist

	@ultima_dist=@perp.length

	haz_muro

	finalundo

	reset

end

def muro_multiplica(value)

	if( @perp.length > 0.0 )

		if !@primer_punto 

			Sketchup.undo

			inicioundo(CambiaIdioma("Paralell wall"))

			longitud=@perp.length

			if value>=1

				paso = longitud 

			else

				paso = longitud*value

				value=1/value

			end

			for i in 1..value

				@perp.length=paso*i

				@primer_punto=@ultimo_punto

				@lbase=Sketchup.active_model.active_entities.add_line @ultp1, @ultp2	

				@ptini = @lbase.start.position.offset(@perp)

				@ptfin = @lbase.end.position.offset(@perp)

				calcula_puntos

				haz_muro

			end

			finalundo

			@perp.length = longitud

			reset

		end

	end	

end

def texto_comando

	texto = CambiaIdioma("墙体厚度")+"["+@@muro_width.to_l.to_s+"]."

	if !@primer_punto

		texto = texto + CambiaIdioma("请选择线段...")

	else

		texto = texto + CambiaIdioma("输入数值或点击放置墙体...")

	end

	texto = texto + ", " + CambiaIdioma("TAB=切换参考“左”“中”“右”") + " '-'."

	if @primer_punto

		texto = texto + " "+CambiaIdioma("")+"."

		texto = texto + " "+CambiaIdioma("")+"."

	end	

	Sketchup::set_status_text texto

end		

def onSetCursor

	UI.set_cursor(@@muropcursor_id)

end

def onMouseMove(flags, x, y, view)

	texto_comando

    return false if !@ip.pick(view, x, y, @ip1) 

	view.tooltip = @ip.tooltip

	if !@primer_punto

		view.invalidate if @arini = busca_cara(x, y, view)

    else

	    @ptfin = @ip.position

        @ptini = @ptfin.project_to_line [@lbase.start,@lbase.end]

        @perp = @ptfin - @ptini

		Sketchup::set_status_text @perp.length.to_s, SB_VCB_VALUE

		@ptini = @lbase.start.position.offset(@perp)

		@ptfin = @lbase.end.position.offset(@perp)

		calcula_puntos

	end

	view.invalidate

end

def onLButtonDown(flags, x, y, view)

	if !@primer_punto

		@ip1.pick(view,x,y,@ip)

		@lbase = busca_cara(x, y, view)

		if @lbase	

			@primer_punto = true

		end	

	else

		create_muro

	end

	texto_comando

	view.lock_inference

end

def onLButtonDoubleClick(flags, x, y, view)

	if @@penultima_dist

		longitud_usuario([@@penultima_dist.to_s],view) if @@penultima_dist>0

	end	

end

def longitud_usuario(valores, view) 

	if( @perp.length > 0.0 )

		if !@primer_punto 

			Sketchup.undo

			@primer_punto=@ultimo_punto

			@lbase=Sketchup.active_model.active_entities.add_line @ultp1, @ultp2

		end

		@perp.length = valores[0].to_l

		@ptini = @lbase.start.position.offset(@perp)

		@ptfin = @lbase.end.position.offset(@perp)

		calcula_puntos

		create_muro

	end	

end

end

class Indoor_Estiramuro < Indoor_Muro

def menu

end	

def reset

	@comando_en_curso = "Extend wall"

	Sketchup.active_model.abort_operation if @primer_punto

	@primer_punto = false

	@pt1 = @pt2 = @pt3 = @pt4 = @vertice1 = @vertice2 = nil

	@arini = @arfin = nil

end

def create_muro

	haz_muro

	finalundo

end

def texto_comando

	texto = CambiaIdioma("墙体延长")+": "

	if !@primer_punto

		texto = texto+CambiaIdioma("请选择线段...")+"."

	else

		texto = texto+CambiaIdioma("请确定终点...")+"."

	end	

	Sketchup::set_status_text texto

end		

def onSetCursor

	UI.set_cursor(@@estiramurocursor_id)

end

def calcula_puntos

	if @arfin 

		pt0 = Geom.intersect_line_line([@pt1, @pt2], @arfin.line)

		@pt1 = pt0 if pt0

		@pt3 = @pt1.project_to_line [@puntos[1], @puntos[3]]

		pt0 = Geom.intersect_line_line([@pt3, @pt4], @arfin.line)

		@pt3 = pt0 if punto_en_segmento(pt0, @arfin.start.position, @arfin.end.position)	

	else

		@pt1 = @ip.position.project_to_line [@puntos[0], @puntos[2]]

		@pt3 = @pt1.project_to_line [@puntos[1], @puntos[3]]

	end

end

def onMouseMove(flags, x, y, view)

	texto_comando

    return false if !@ip.pick(view, x, y, @ip1) 

	view.tooltip = @ip.tooltip

	if !@primer_punto

		view.invalidate if @arini = busca_cara(x, y, view)

    else

		@arfin = busca_cara(x, y, view)

		calcula_puntos

	end

	view.invalidate

end

def onLButtonDown(flags, x, y, view)

	if !@primer_punto

		pt = @ip.position

		cara = busca_cara(x, y, view)

		if cara	

			otracara=otra_cara_perp(cara, pt)

			return false if !otracara

			inicioundo(CambiaIdioma("Extend wall"))

			@puntos = borra_muro(x, y, view, false)

			lado =(@puntos[0] - pt).length - (@puntos[2] - pt).length

			if lado	<= 0 

				@pt1 = @puntos[0]

				@pt2 = @puntos[2]

				@pt3 = @puntos[1]

				@pt4 = @puntos[3]

			else

				@pt1 = @puntos[2]

				@pt2 = @puntos[0]

				@pt3 = @puntos[3]

				@pt4 = @puntos[1]

			end	

			@primer_punto = true

			@arini = nil

			calcula_puntos

		end	

		@ip1.copy! @ip

	else

		@primer_punto = false

		create_muro

		reset

	end

	texto_comando

	view.lock_inference

	view.invalidate

end

end

class Indoor_Carpinteria < Indoor_Base

def activate

	menu

end	

def init_carpinteria

	@grueso_muro=0.25.m if !@grueso_muro

	@ip = Sketchup::InputPoint.new

	@transform = Geom::Transformation.new

	@cara1 = @carpinteria = nil

	@angulo1 = 0.0

	@angulo2 = Math::PI*3/2

	Sketchup::set_status_text "", SB_VCB_LABEL

	Sketchup::set_status_text "", SB_VCB_VALUE

	@simetria_hueco = 1

	@pulsado_alt = false

	texto_comando

end

def siguiente_punto(x, y)

	ult = @p_c.last

	@p_c.push [ult[0]+x, ult[1]+y]

end

def siguiente_punto_rep(x, y)

	ult = @p_c.last

	@p_c.push [ult[0], ult[1]]

	@p_c.push [ult[0]+x, ult[1]+y]

end

def siguiente_linea(x1, y1, x2, y2)

	ult = @p_c.last

	@p_c.push [ult[0]+x1, ult[1]+y1]

	@p_c.push [ult[0]+x1+x2, ult[1]+y1+y2]

end

def set_transform(enmuro)

	pi =Math::PI

	if @angulo1 < pi/2  

		if @angulo2 > pi 

			@angulo2=@angulo2-2*pi

		end

	end	

	if @angulo1 >= 3*pi/2  

		if @angulo2 < pi 

			@angulo2=@angulo2+2*pi

		end

	end	

	if !enmuro

		@transform = Geom::Transformation.translation @ph1-[@carpinteria_hueco*@ancho/2,0,0] 

	else	

		@transform = Geom::Transformation.translation @ph1

	end	

	@transform =(Geom::Transformation.scaling @ph1,1,-1,1) * @transform if @angulo2 > @angulo1

	@transform =(Geom::Transformation.rotation @ph1, [0,0,1], @angulo1) * @transform 

end

def hueco_maximo(extremos1, extremos2)

	return tramo_comun(extremos1, extremos2)

end

def extremo_mocheta(p1,m,p2)

	m.vertices.each do |v|

		 if v.position == p1

			v.edges.each do |e|

				if e != m

					otrovertice = e.other_vertex(v).position

					return otrovertice if otrovertice.on_line?([p1,p2])

				end

			end

		 end

	end

	return p1	

end

def puntos_hueco (posicion)

	if !@carpinteria

		@cara1 = @cara_ventana if @cara_ventana

		return false if !@cara1 

		@cara2 = otra_cara_perp(@cara1, posicion)	

		return false if !@cara2

		extremos1=edge_extremos(@cara1)

		extremos2=edge_extremos(@cara2)

	else

		ptos1 = muro_carpinteria(@carpinteria)

		mochetas = [mocheta_puntos(ptos1[0],ptos1[1]),mocheta_puntos(ptos1[2],ptos1[3])]

		direccion = (ptos1[0]-ptos1[3])

		ptos2=[]

		if mochetas[0]

			ptos2.push(extremo_mocheta(ptos1[0],mochetas[0],ptos1[3])	)	

			ptos2.push(extremo_mocheta(ptos1[1],mochetas[0],ptos1[2])	)	

		else

			ptos2.push(ptos1[0])	

			ptos2.push(ptos1[1])	

		end

		if mochetas[1]	

			ptos2.push(extremo_mocheta(ptos1[2],mochetas[1],ptos1[1])	)	

			ptos2.push(extremo_mocheta(ptos1[3],mochetas[1],ptos1[0])	)	

		else	

			ptos2.push(ptos1[2])	

			ptos2.push(ptos1[3])

		end	

		if @maximo_hueco || @comando_en_curso == "Place wardrobe" || @@forzar_carpinteria || @carpinteria_hueco != 0

			extremos1=[ptos2[0],ptos2[3]]

			extremos2=[ptos2[1],ptos2[2]]

			posicion=posicion.project_to_line(extremos1)

			posicion=punto_medio(ptos1[0],ptos1[3]) if @carpinteria_hueco != 0

		elsif posicion.distance(ptos1[0]) < posicion.distance(ptos1[3])

			extremos1=[ptos1[0],ptos2[3]]

			extremos2=[ptos1[1],ptos2[2]]

			posicion=ptos1[0]

		else	

			extremos1=[ptos2[0],ptos1[3]]

			extremos2=[ptos2[1],ptos1[2]]

			posicion=ptos1[3]

		end

	end

	@ancho_anterior = @ancho

	ptos = hueco_maximo(extremos1, extremos2)

	return false if !ptos

	ptini = ptos[0]

	ptfin = ptos[1]

	@angulo1 = angulo_recta(ptos[0], ptos[1])

	@angulo2 = angulo_recta(ptos[0], ptos[0].project_to_line(extremos2))

	@grueso_muro =(ptos[0]- ptos[0].project_to_line(extremos2)).length

	if @simetria_hueco != 1 

		ptref1 = ptfin 

		ptref2 = ptini

	else

		ptref1 = ptini

		ptref2 = ptfin

	end	

	if @maximo_hueco || @comando_en_curso == "Place wardrobe"

		@ph1 = ptref1

		@ancho =(ptini - ptfin).length

	elsif @@forzar_carpinteria

		if(posicion-ptini).length <(posicion-ptfin).length	

			@simetria_hueco = 1

			ptref1 = ptini

			ptref2 = ptfin

		else

			@simetria_hueco = -1

			ptref1 = ptfin

			ptref2 = ptini

		end	

		if @carpinteria_hueco != 0

			@ph1 = punto_a_distancia(punto_medio(ptref1, ptref2), posicion, @ancho/2)

		else

			@ph1 = punto_a_distancia(ptref1, posicion, @distancia_carpinteria)

		end	

	else

		@ph1 = punto_a_distancia(posicion, ptref1, @ancho*@carpinteria_hueco/2)

	end

	if !punto_en_segmento(@ph1, ptini, ptfin)

		@ancho = @ancho_anterior

		return false 		

	end

	@ptperp=@ph1.project_to_line(extremos2)

	@ph2 = @ptperp

	vuelta = 0

	while vuelta < 2

		if ptref1 == ptini

			ptref1 = ptfin

			ptref2 = ptini

		else	

			ptref1 = ptini

			ptref2 = ptfin

		end  if @ph1 == ptref2

		@simetria_hueco = -@simetria_hueco if @ph3 != punto_a_distancia(@ph1, ptref2, @ancho) && @primer_punto 

		@ph3 = punto_a_distancia(@ph1, ptref2, @ancho)

		@ph4 = @ph3.project_to_line(extremos2) 

		@angulo1 = angulo_recta(@ph1, @ph3) if @ancho>0

		@angulo2 = angulo_recta(@ph1, @ph2)

		if punto_en_segmento(@ph3, ptini, ptfin)

			if @carpinteria

				return true

			else 

				return true if	otra_cara_perp(@cara1, @ph3) == @cara2

			end	

		end	

		return false if @primer_punto

		@simetria_hueco = -@simetria_hueco 

		if ptref1 == ptini

			ptref1 = ptfin

			ptref2 = ptini

		else	

			ptref1 = ptini

			ptref2 = ptfin

		end  

		vuelta += 1

	end

	@ancho = @ancho_anterior

	return false

end

def draw(view)

	return if !@ancho || !@p_c

	textoevaluacion(view)

    if( @ip.valid? && @ip.display? )

        @ip.draw(view)

    end

	if @primer_punto 

		pto_carpinteria = @primer_punto

	else

		pto_carpinteria = @ip.position

	end

	if puntos_hueco(pto_carpinteria)

		set_transform(true)

		puntos_carpinteria(true) if !@primer_punto

		view.drawing_color = "magenta"

		view.line_width = 2

		view.draw(GL_LINES, @ph1, @ph2)  

		view.draw(GL_LINES, @ph3, @ph4)

	else 

		view.drawing_color = "black"

		view.line_width = 1

		@ph1 = pto_carpinteria

		set_transform(false) 

	end

	ptos = []

	@p_c.each do |pt|

		ptos.push pt.transform(@transform)

	end 

	view.draw(GL_LINES, ptos)  if ptos  != []

end

def onMouseMove(flags, x, y, view)

    return false if( !@ip.pick(view, x, y) )

    texto_comando

	view.tooltip = @ip.tooltip

	if !@primer_punto

		@cara1 = busca_cara(x, y, view)

		@carpinteria = nil

		@carpinteria = busca_carpinteria(x, y, view) if !@cara1

		if !@carpinteria

			@ph1 = @ip.position

		else

		end

	else	

		@ancho=0 

		puntos_carpinteria(false)

	end

	view.invalidate

end

def colocar_carpinteria

	if @cara1 && @pulsado_alt

		if !@primer_punto

			@primer_punto = @ph1

			@cara_ventana = @cara1

			return

		else

			@ph1 = @primer_punto

			Sketchup::set_status_text CambiaIdioma("Length"), SB_VCB_LABEL

		end

	end

	if @primer_punto 

		pto_carpinteria = @primer_punto

	else

		pto_carpinteria = @ip.position

	end

	if puntos_hueco(pto_carpinteria)

		set_transform(true)

		inicioundo(CambiaIdioma(@comando_en_curso))

		if @carpinteria

			borra_carpinteria(@carpinteria)

			@carpinteria=nil

		end

		Sketchup.active_model.active_entities.add_line(@ph1, @ph2)

		Sketchup.active_model.active_entities.add_line(@ph3, @ph4)

		lborrar = Sketchup.active_model.active_entities.add_line @ph1, @ph3

		Sketchup.active_model.active_entities.erase_entities lborrar

		lborrar = Sketchup.active_model.active_entities.add_line @ph2, @ph4

		Sketchup.active_model.active_entities.erase_entities lborrar

		carp = pon_carpinteria

		pon_color(carp,@@color_lineas)

		$dc_observers.get_latest_class.redraw_with_undo(carp)

		@primer_punto = @cara_ventana = false

	else

		@simetria_hueco = -@simetria_hueco

		@angulo1 = angulo_inverso(@angulo1)

		@angulo2 = @angulo2 +2*Math::PI if @angulo2<0.0

		puntos_carpinteria(false)

	end

	reset

end

def onLButtonDown(flags, x, y, view)

		colocar_carpinteria

end

def ancho_maximo(vf)

	return if @comando_en_curso == "Place door"

	@maximo_hueco = vf 

	@pulsado_alt = false

end

def hueco_a_distancia(vf)

	@@forzar_carpinteria = vf

	@maximo_hueco = false

end

def hueco_pantalla(vf)

	return if @comando_en_curso != "Place window"

	@pantalla = vf

	@maximo_hueco = false

	reset

	return if !vf

	if otra_cara_perp(@cara1, @ip.position) 

		@primer_punto = @ip.position

		@cara_ventana = @cara1

		@ancho=0

	end if @cara1

end

def hueco_anterior

	if @ancho_anterior

		@ancho = @ancho_anterior

		puntos_carpinteria(false)

	end

end

def onKeyDown(key, rpt, flags, view)

	if(key == 9) ||(key==VK_CONTROL) then

		@carpinteria_hueco += 1

		@carpinteria_hueco = 0 if @carpinteria_hueco > 1

		view.invalidate

	elsif key == CONSTRAIN_MODIFIER_KEY && !@primer_punto

		ancho_maximo(true)

		view.invalidate

	elsif key == COPY_MODIFIER_KEY && !@primer_punto

		@@forzar_carpinteria=true

		view.invalidate

	elsif key == ALT_MODIFIER_KEY

		@pulsado_alt=true

		if !@primer_punto

			hueco_pantalla(true)

			view.invalidate

		else

			@primer_punto=nil

		end	

	end	

	texto_comando

	no_menu=true if key == ALT_MODIFIER_KEY

end	

def onKeyUp(key, rpt, flags, view)

	if key == CONSTRAIN_MODIFIER_KEY && !@primer_punto

		ancho_maximo(false)

		view.invalidate

	elsif key == COPY_MODIFIER_KEY && !@primer_punto

		@@forzar_carpinteria=false

		view.invalidate

	elsif key == ALT_MODIFIER_KEY 

		@pulsado_alt=false

		if !@primer_punto

			hueco_pantalla(false)

			@@forzar_carpinteria=false

			view.invalidate

		end	

	end

	hueco_anterior if !@pantalla

end

def onCancel(flag, view)

	reset

	hueco_pantalla(false) if !@pulsado_alt

	view.invalidate

end

def forzar_hueco(text)

	return false if text[0].chr != "-"

	valores = text.split("-")

	if valores.size > 1

		@distancia_carpinteria =(con_coma(valores[1],nil).to_l).abs

	else		

	end

	return true

end

end

class Indoor_Puerta < Indoor_Carpinteria

def initialize

	@distancia_carpinteria = 0.10.m if !@distancia_carpinteria

	@carpinteria_hueco = @@puerta_hueco

	@comando_en_curso = "Place door"

	init_carpinteria

end

def menu

	prompts = 	[	CambiaIdioma("Slab")+" 1",

							CambiaIdioma("Slab")+" 2",

							CambiaIdioma("Lintel"),

							CambiaIdioma("Force"),

							CambiaIdioma("Align")

						]

	

	distancia =(@distancia_carpinteria.to_l).to_s

	

	case @@puerta_alineacion

	when 0.0

		alineacion=CambiaIdioma("Internal")

	when 0.5 

		alineacion=CambiaIdioma("Center")

	when 1.0

		alineacion=CambiaIdioma("External")

	end

	defaults =	[	@@puerta_hoja1.to_l.to_s,

						@@puerta_hoja2,

						@@puerta_dintel.to_l.to_s,

						distancia,

						alineacion

					]

	list = 		[	"",

						"",

						"",

						"",

						CambiaIdioma("Internal")+"|"+CambiaIdioma("Center")+"|"+CambiaIdioma("External")

					]

	input = UI.inputbox prompts, defaults, list, CambiaIdioma("Door")

	if input

		h1 = a_longitud(input[0]).abs

		h1 = @@puerta_hoja1 if h1 == 0

		h2 =(input[1].to_s)

		@@puerta_hoja1 = h1

		@@puerta_hoja2 = texto_hoja2(h2)		

	else

		Sketchup.active_model.select_tool nil	

		return

	end

	h1 = a_longitud(input[2]).abs

	@@puerta_dintel = h1 if h1 > 0

	@distancia_carpinteria = a_longitud(input[3]).abs

	case input[4].to_s

	when CambiaIdioma("Internal") 

		@@puerta_alineacion=0.0

	when CambiaIdioma("Center") 

		@@puerta_alineacion=0.5

	when CambiaIdioma("External")

		@@puerta_alineacion=1.0

	end			

	reset

end

def reset

	puntos_carpinteria(false)

end 

def deactivate(view)

	@@puerta_hueco = @carpinteria_hueco 

	view.invalidate

end

def texto_comando

	texto = CambiaIdioma("Door")+" [" + @@puerta_hoja1.to_l.to_s

	texto = texto +@@separador_listas+@@puerta_hoja2

	texto = texto +"] ["+CambiaIdioma("Force")+" "

	texto = texto + @distancia_carpinteria.to_l.to_s 

	texto = texto +"]. "+CambiaIdioma("Select a wall, new values, or distance preceded by")

	texto=texto+" '-', Ctrl="

	texto=texto+" '-', Option="

	texto = texto +CambiaIdioma("Force")

	texto = texto +", Tab="+CambiaIdioma("Center/End")

	texto = texto +", Ctrl="+CambiaIdioma("Center/End")

	Sketchup::set_status_text texto

end

def puntos_carpinteria(enmuro)

	y=0.0

	gruesomarco=@@puerta_grueso_marco

	if enmuro

		gruesomarco=(@ph1 - @ph2).length if gruesomarco >(@ph1 - @ph2).length

		y=@@puerta_alineacion*(gruesomarco-(@ph1 - @ph2).length)

	end	

	@p_c = []

	@ancho = @@puerta_hoja1+medida_hoja2+2*@@puerta_ancho_marco

	if medida_hoja2 > 0 

		@p_c.push [@@puerta_ancho_marco + @@puerta_hoja1 +  medida_hoja2,  medida_hoja2+y]

		siguiente_punto(-@@puerta_grueso_hoja, 0) 			

		siguiente_punto_rep(0 , -medida_hoja2) 			

		siguiente_punto_rep(@@puerta_grueso_hoja, 0) 

		siguiente_punto_rep(@@puerta_ancho_marco,0)

	else

		@p_c.push [@@puerta_ancho_marco + @@puerta_hoja1, y]

		siguiente_punto(@@puerta_ancho_marco,0)

	end

	 

	siguiente_punto_rep(0,-gruesomarco) 

	siguiente_punto_rep(-@@puerta_ancho_marco, 0)

	siguiente_punto_rep(0, gruesomarco)

	if  medida_hoja2 > 0

		siguiente_punto_rep(0,  medida_hoja2)

		alfa = Math::PI/2

		while alfa < Math::PI - 0.00001 

			alfa = alfa +  Math::PI / 18

			siguiente_punto_rep(-medida_hoja2*(Math::cos(alfa-Math::PI / 18)-Math::cos(alfa)), medida_hoja2*(Math::sin(alfa)-Math::sin(alfa-Math::PI / 18)))

		end

	end	

	alfa = 0

	while alfa < Math::PI/2 -0.0001

		alfa = alfa +  Math::PI / 18

		siguiente_punto_rep(-@@puerta_hoja1*(Math::cos(alfa-Math::PI / 18)-Math::cos(alfa)), @@puerta_hoja1*(Math::sin(alfa)-Math::sin(alfa-Math::PI / 18)))

	end

	siguiente_punto_rep(0, -@@puerta_hoja1 - gruesomarco)

	siguiente_punto_rep(-@@puerta_ancho_marco, 0)

	siguiente_punto_rep(0, gruesomarco)

	siguiente_punto_rep(@@puerta_ancho_marco + @@puerta_grueso_hoja, 0) 

	siguiente_punto_rep(0, @@puerta_hoja1)

	siguiente_punto_rep(-@@puerta_grueso_hoja, 0)

end

def pon_carpinteria

	if medida_hoja2 > 0

		@pathcarpinteria = Sketchup.find_support_file("Indoor_PUERTA_DOBLE.skp", "Plugins/AF_Indoor")

	else

		@pathcarpinteria = Sketchup.find_support_file("Indoor_PUERTA.skp", "Plugins/AF_Indoor")

	end	

	componente = Sketchup.active_model.definitions.load(@pathcarpinteria)

	inicioundo(CambiaIdioma(@comando_en_curso))

	pu = Sketchup.active_model.active_entities.add_instance componente, @transform

	pu.set_attribute "dynamic_attributes", "mocheta",(@ph1 - @ph2).length*1.0

	pu.set_attribute "dynamic_attributes", "a01hoja1", @@puerta_hoja1*1.0

	pu.set_attribute "dynamic_attributes", "a01hoja2", medida_hoja2*1.0

	pu.set_attribute "dynamic_attributes", "a02dintel", @@puerta_dintel.abs*1.0

	pu.set_attribute "dynamic_attributes", "a02gruesoh", @@puerta_grueso_hoja*1.0 

	pu.set_attribute "dynamic_attributes", "anchomarco", @@puerta_ancho_marco*1.0 

	pu.set_attribute "dynamic_attributes", "gruesmarco", @@puerta_grueso_marco*1.0 

	pu.set_attribute "dynamic_attributes", "a02alineac", @@puerta_alineacion*1.0  

	return pu

end

def texto_hoja2(texto)

	if "=+-*/".index(texto[0])

		prefijo=texto[0].chr

		valores=texto.split(prefijo)

		sufijo = con_coma(valores[1],'.').to_f.to_s if valores.size > 1 

		h2=prefijo

		if sufijo

			if h2 == "="	

				h2 = sufijo.to_l.abs if sufijo.to_l.abs > 0

			else 

				h2 = h2+sufijo

			end	

		else 

			h2='0' if h2 != "="

		end

	else

		h2 =(con_coma(texto,nil).to_l).abs.to_l.to_s

	end

	return h2

end

def medida_hoja2

	return @@puerta_hoja1 if @@puerta_hoja2 == "="

	if "+-*/".index(@@puerta_hoja2[0])

		prefijo=@@puerta_hoja2[0].chr

		valores=@@puerta_hoja2.split(prefijo)

		sufijo = con_coma(valores[1],'.') if valores.size > 1 

		case prefijo

		when "+"

			h2 = @@puerta_hoja1+ con_coma(sufijo,nil).to_l

		when "-"

			h2 = @@puerta_hoja1- con_coma(sufijo,nil).to_l

		when "*"

			h2 = @@puerta_hoja1* sufijo.to_f

		when "/"

			h2 = @@puerta_hoja1/sufijo.to_f

		end

	else

		h2=@@puerta_hoja2.to_l

	end	

	h2=0 if h2 < 0 

	return h2

end	

def onUserText(text, view)

    if !forzar_hueco(text)

		valores = text.split(@@separador_listas)

		begin

			h1 =(con_coma(valores[0],nil).to_l).abs

		rescue	

			h1 = 0

		end	

		h1=@@puerta_hoja1 if h1 == 0

		@@puerta_hoja1 = h1

		@@puerta_hoja2 = texto_hoja2(valores[1]) if valores.size > 1

		puntos_carpinteria(false)

	end	

	texto_comando

	view.invalidate

end

end

 

class Indoor_Ventana < Indoor_Carpinteria

def initialize

	@distancia_carpinteria = 0.10.m if !@distancia_carpinteria

	@carpinteria_hueco = @@ventana_hueco

	@grueso_muro = 0.25.m if !@grueso_muro

	@comando_en_curso = "Place window"

	init_carpinteria

end

def menu

	prompts = [	CambiaIdioma("Length"),

						CambiaIdioma("Height"),

						CambiaIdioma("Sashes"),

						CambiaIdioma("Sill"),

						CambiaIdioma("Force"),

						CambiaIdioma("Align")

					 ] 

	ancho =(@@ventana_ancho.to_l).to_s

	hojas =(@@ventana_hojas.to_i).to_s

	hojas = '<'+(@@ventana_hojamax.to_l).to_s if @@ventana_hojamax > 0 

	distancia =(@distancia_carpinteria.to_l).to_s 

	case @@ventana_alineacion

	when 0.0

		alineacion=CambiaIdioma("Internal")

	when 0.5 

		alineacion=CambiaIdioma("Center")

	when 1.0

		alineacion=CambiaIdioma("External")

	end

	

	defaults = [	ancho,

						@@ventana_alto.to_l.to_s,

						hojas,

						@@ventana_alfeizar.to_l.to_s,

						distancia,

						alineacion

					]

	list = 		[	"",

						"",

						"",

						"",

						"",

						CambiaIdioma("Internal")+"|"+CambiaIdioma("Center")+"|"+CambiaIdioma("External")

					]

	input = UI.inputbox prompts, defaults, list, CambiaIdioma("Window")

	if input

		ancho_ventana(input[0])

		h1 =a_longitud(input[1]).abs

		@@ventana_alto = h1 if h1>0

		h1 = con_coma(input[2],nil)

		if h1[0].chr == "<"	

			@@ventana_hojamax = h1.split("<")[1].to_l.abs 

		else

			if h1.to_i  > 0

				@@ventana_hojas = h1.to_i.abs

				@@ventana_hojamax = 0 

			end	

		end	

		@@ventana_alfeizar = a_longitud(input[3]).abs

		@distancia_carpinteria = a_longitud(input[4]).abs

		hueco_anterior

	else

		Sketchup.active_model.select_tool nil

		return

	end	

	case input[5].to_s

	when CambiaIdioma("Internal") 

		@@ventana_alineacion=0.0

	when CambiaIdioma("Center") 

		@@ventana_alineacion=0.5

	when CambiaIdioma("External")

		@@ventana_alineacion=1.0

	end

	reset

end 

def reset

	@ancho = @@ventana_ancho

	@primer_punto = @cara_ventana = false

	@hojamax = @@ventana_hojamax

	puntos_carpinteria(false)

	@pantalla=false if !@pulsado_alt

end	

def ancho_ventana(valor)

	h1 =a_longitud(valor).abs

	@@ventana_ancho = h1 if h1>0

end

def deactivate(view)

	@@ventana_hueco = @carpinteria_hueco 

	view.invalidate

end

def texto_comando

	texto = CambiaIdioma("Window")+" [" +@@ventana_ancho.to_l.to_s  + @@separador_listas

	if @@ventana_hojamax == 0

		texto = texto + @@ventana_hojas.to_i.to_s  

	else	

		texto = texto + "<" + @@ventana_hojamax.to_l.to_s 

	end	

	texto = texto +"] ["+CambiaIdioma("Force")+" "+ @distancia_carpinteria.to_l.to_s

	texto = texto + "]. "

	if @pantalla && @primer_punto

		texto=texto+CambiaIdioma("End")

	else

		texto = texto +CambiaIdioma("Wall")

	end

	if !@pantalla && !@maximo_hueco && !@@forzar_carpinteria

		texto = texto +", "+CambiaIdioma("values or distance")

		texto=  texto +"(-), Ctrl="+CambiaIdioma("Force")

		texto=  texto +"(-), Option="+CambiaIdioma("Force")

		texto = texto +", Tab="+ CambiaIdioma("Cen./End")+", "

		texto = texto +", Ctrl="+ CambiaIdioma("Cen./End")+", "

		texto = texto + CambiaIdioma("Shift")+"="+CambiaIdioma("Max.")

		texto = texto +", Alt= <->"

		texto = texto +", Cmd= <->"

	end	

	Sketchup::set_status_text texto;

end

def puntos_carpinteria(enmuro)

	y=@@ventana_alineacion*(@@ventana_grueso-@grueso_muro)

	@p_c = []

	@hojamax = @@ventana_hojamax if !@primer_punto

	if @pantalla

		if !@primer_punto

			@ancho = 0

			return	

		else

			@ph3 = @ip.position.project_to_line(@cara_ventana.line)

			longi=(@primer_punto - @ph3).length

			if longi>0 && @ancho==0

				@ancho =longi

				@ancho *=2 if @carpinteria_hueco != 0

				Sketchup::set_status_text @ancho.to_l.to_s, SB_VCB_VALUE

			end	

		end

	else

		@ancho = @@ventana_ancho if !@maximo_hueco

	end

	if @hojamax > 0

		@hojas =(0.4999+@ancho/@hojamax).round

	else

		@hojas = @@ventana_hojas if !@primer_punto

	end	

	cristal =(@ancho-2*@@ventana_ancho_marco*(1+@hojas))/@hojas

	@p_c.push [0, y]

	siguiente_punto(@ancho, 0)

	siguiente_punto_rep(0, -@@ventana_grueso)

	siguiente_punto_rep(-@ancho, 0)

	siguiente_punto_rep(0, @@ventana_grueso)

	@p_c.push [@@ventana_ancho_marco, y]

	siguiente_punto(0, -@@ventana_grueso)

	@p_c.push [2*@@ventana_ancho_marco, y]

	siguiente_punto(0, -@@ventana_grueso)

	for i in 1 .. @hojas

		siguiente_linea(0, @@ventana_grueso/2, cristal, 0) 

		siguiente_linea(0, @@ventana_grueso/2, 0, -@@ventana_grueso) 

		siguiente_linea(@@ventana_ancho_marco, 0, 0, @@ventana_grueso)

		siguiente_linea(@@ventana_ancho_marco, 0, 0, -@@ventana_grueso)

	end	

	@p_c.push [-@@ventana_lateral_alfeizar, 0]

	siguiente_punto(0, -@grueso_muro-@@ventana_frontal_alfeizar)

	siguiente_punto_rep(@ancho+2*@@ventana_lateral_alfeizar, 0)

	siguiente_punto_rep(0, @grueso_muro+@@ventana_frontal_alfeizar)

	siguiente_punto_rep(-@ancho-2*@@ventana_lateral_alfeizar, 0)

	@ancho = @@ventana_ancho if !@pantalla

end

def pon_carpinteria

	@pathcarpinteria = Sketchup.find_support_file("Indoor_VENTANA.skp", "Plugins/AF_Indoor")

	componente = Sketchup.active_model.definitions.load(@pathcarpinteria)

	inicioundo(CambiaIdioma(@comando_en_curso))

	ve = Sketchup.active_model.active_entities.add_instance componente, @transform

	ve.set_attribute "dynamic_attributes", "mocheta", @grueso_muro*1.0

	ve.set_attribute "dynamic_attributes", "a01ancho", @ancho*1.0

	ve.set_attribute "dynamic_attributes", "a02alto", @@ventana_alto*1.0

	ve.set_attribute "dynamic_attributes", "a03alfeizar", @@ventana_alfeizar*1.0

	ve.set_attribute "dynamic_attributes", "a02hojas", @hojas

	ve.set_attribute "dynamic_attributes", "a02alineac", @@ventana_alineacion

	return ve

end

def onUserText(text, view)

	text=con_coma(text,nil)

    if !forzar_hueco(text)

		valores = text.split(@@separador_listas)

		n1 = con_coma(valores[0],nil).to_l

		if !@pantalla

			ancho_ventana(n1) if n1

		else

			n1=a_longitud(n1).abs

			@ancho=n1 if n1>0 

		end

		if valores.size > 1

			n2 =valores[1]

			if n2[0].chr == "<"		

				@hojamax = n2.split("<")[1].to_l.abs  

			else

				if n2.to_i  > 0

					@hojas = n2.to_i

					@@ventana_hojas = @hojas if !@primer_punto

					@hojamax = 0

				end	

			end	

			@@ventana_hojamax = @hojamax if !@primer_punto

		end

		puntos_carpinteria(false)

	end	

	texto_comando

	

	colocar_carpinteria if @primer_punto && n1>0

	view.invalidate

end

end

 

class Indoor_Armario < Indoor_Carpinteria

def initialize

	@hoja_armario = @@armario_hoja1

	@carpinteria_hueco = 1

	@comando_en_curso = "Place wardrobe"

	init_carpinteria

end

def menu

	@ancho = 1.0.m if !@ancho

	prompts = 	[	CambiaIdioma("Slab"),

							CambiaIdioma("Threshold"),

							CambiaIdioma("Lintel"),

						]

						

	defaults = 	[	@@armario_hoja1.to_l.to_s,

							@@armario_umbral.to_l.to_s,

							@@armario_dintel.to_l.to_s

						]

						

	alto_minimo = 3*@@armario_ancho_marco+0.72.m					

	list = 			[	"",

							"",

							""

						]

	input = UI.inputbox prompts, defaults, list, CambiaIdioma("Wardrobe")

	if input

		alto_minimo = 2*@@armario_ancho_marco+0.20.m

		h1 = a_longitud(input[0]).abs

		@@armario_hoja1 = h1 if h1>0

		h1 = a_longitud(input[1]).abs

		@@armario_umbral = h1 if h1>=0

		h1 = a_longitud(input[2]).abs

		@@armario_dintel = h1 if h1>=0

		if @@armario_umbral+alto_minimo>@@armario_dintel

			@@armario_dintel = @@armario_umbral+alto_minimo

		end

	else	

		Sketchup.active_model.select_tool nil	

		return

	end	

	reset

end

def reset

	puntos_carpinteria(false)

end 

def deactivate(view)

	view.invalidate

end

def texto_comando

	texto = CambiaIdioma("Wardrobe")+" [" + @@armario_hoja1.to_l.to_s  + "]. "

	texto = texto +CambiaIdioma("Enter a wall, or new dimension for doors")+". " +CambiaIdioma("Shift")+"="+CambiaIdioma("Max. length")

	Sketchup::set_status_text texto

end

def ancho_arm(hojas)

	marcos =((hojas+1)/2).to_i+1

	return marcos*@@armario_ancho_marco+hojas*@hoja_armario

end

def hueco_maximo(extremos1, extremos2)

	@hoja_armario = @@armario_hoja1

	ptos = tramo_comun(extremos1,extremos2)

	ptini = ptos[0]

	ptfin = ptos[1]

	anch =(ptini-ptfin).length

	maxhojas =(anch / @hoja_armario).to_i

	maxhojas -= 1 while ancho_arm(maxhojas) > anch

	if @maximo_hueco

		maxhojas = 1 if maxhojas == 0

		marcos =((maxhojas+1)/2).to_i+1

		return false if marcos*@@armario_ancho_marco > anch

		@hoja_armario =(anch-marcos*@@armario_ancho_marco)/maxhojas

	end

	return false if maxhojas == 0

	@@armario_ancho = anch = ancho_arm(maxhojas)

	@@armario_hojas = maxhojas

	ptini = punto_a_distancia(punto_medio(ptini, ptfin), ptini, anch/2)

	ptfin = punto_a_distancia(ptini, ptfin, anch)

	return[ptini, ptfin]

end

def marco(punto)

	@p_c.push punto

	siguiente_punto(@@armario_ancho_marco, 0)

	siguiente_punto_rep(0, -@@armario_grueso_marco)

	siguiente_punto_rep(-@@armario_ancho_marco, 0)

	siguiente_punto_rep(0, @@armario_grueso_marco)

end

def hoja_izquierda

	cos15=Math.cos(15*Math::PI/180)

	sin15=Math.sin(15*Math::PI/180)

	siguiente_linea(@@armario_ancho_marco,0,@hoja_armario*cos15, @hoja_armario*sin15)

	siguiente_punto_rep(@@armario_grueso_hoja*sin15, -@@armario_grueso_hoja*cos15)

	siguiente_punto_rep(-@hoja_armario*cos15, -@hoja_armario*sin15)

	siguiente_punto_rep(-@@armario_grueso_hoja*sin15, @@armario_grueso_hoja*cos15)

	siguiente_linea(@hoja_armario*cos15, @hoja_armario*sin15,@hoja_armario*(1-cos15), -@hoja_armario*sin15)

	siguiente_punto_rep(@@armario_grueso_hoja/sin15-@hoja_armario, 0)

	siguiente_linea(@hoja_armario-@@armario_grueso_hoja/sin15,-@@armario_grueso_marco,-@hoja_armario,0)	

end

def hoja_derecha

	cos15=Math.cos(15*Math::PI/180)

	sin15=Math.sin(15*Math::PI/180)

	siguiente_linea(-@hoja_armario*cos15, @hoja_armario*sin15,-@hoja_armario*(1-cos15), -@hoja_armario*sin15)

	siguiente_punto_rep(@hoja_armario-@@armario_grueso_hoja/sin15, 0)

	siguiente_linea(@@armario_grueso_hoja/sin15-@hoja_armario,-@@armario_grueso_marco,@hoja_armario,0)	

	siguiente_linea(0,@@armario_grueso_marco,-@hoja_armario*cos15, @hoja_armario*sin15)

	siguiente_punto_rep(-@@armario_grueso_hoja*sin15, -@@armario_grueso_hoja*cos15)

	siguiente_punto_rep(@hoja_armario*cos15, -@hoja_armario*sin15)

	siguiente_punto_rep(@@armario_grueso_hoja*sin15, @@armario_grueso_hoja*cos15)

end

def puntos_carpinteria(enmuro)

	@p_c = []

	for i in 0 ..((@@armario_hojas+1)/2).to_i-1

		marco([i*(2*@hoja_armario+@@armario_ancho_marco), 0])

		hoja_derecha if(i != 0)

		hoja_izquierda if(@@armario_hojas % 2 == 0) or(i !=((@@armario_hojas+1)/2).to_i-1)

	end	

	marco([@@armario_ancho-@@armario_ancho_marco, 0])

	hoja_derecha

end	

def pon_carpinteria

	if @@armario_hojas == 1

		@pathcarpinteria = Sketchup.find_support_file("Indoor_ARMARIO_1.skp", "Plugins/AF_Indoor")

	else

		@pathcarpinteria = Sketchup.find_support_file("Indoor_ARMARIO_2.skp", "Plugins/AF_Indoor")

	end	

	componente = Sketchup.active_model.definitions.load(@pathcarpinteria)

	inicioundo(CambiaIdioma(@comando_en_curso))

	ar = Sketchup.active_model.active_entities.add_instance componente, @transform

	ar.set_attribute "dynamic_attributes", "mocheta", @grueso_muro*1.0

	ar.set_attribute "dynamic_attributes", "a01ancho", @@armario_ancho*1.0

	ar.set_attribute "dynamic_attributes", "a01hojas", @@armario_hojas

	ar.set_attribute "dynamic_attributes", "a01umbral", @@armario_umbral*1.0

	ar.set_attribute "dynamic_attributes", "a02dintel", @@armario_dintel*1.0

	return ar

end

def onUserText(text, view)

	text=con_coma(text,nil)

    if !forzar_hueco(text)

		n1 = text.to_l

		@@armario_hoja1 = n1 if n1 > 0

		@@armario_ancho = ancho_arm(@@armario_hojas)

		puntos_carpinteria(false)

	end	

	view.invalidate

end

end

class Indoor_CotaContinua < Indoor_Base

def initialize

	@ip = Sketchup::InputPoint.new

	@ip1 = Sketchup::InputPoint.new

	reset

end

def reset

	if @grupo

		pt = @ptpos.project_to_line [@ptini,@ptfin]

		@grupo.transform!(Geom::Transformation.translation(pt - @ptpos))	

		@grupo.explode

		finalundo

	end	

	@ptini = @ptfin = @ptint = @ptpos = @grupo = false

	Sketchup::set_status_text "", SB_VCB_LABEL

	Sketchup::set_status_text "", SB_VCB_VALUE

	texto_comando

end

def texto_comando

	texto = CambiaIdioma("Continuous dimension")+"("+CambiaIdioma("min.")+" "+@@cota_minima.to_l.to_s+"): "

	if !@ptini

		texto = texto + CambiaIdioma("Enter start point, or minimun value")

	elsif !@grupo

		texto = texto + CambiaIdioma("Enter end point, or minimun value")

	else

		texto = texto + CambiaIdioma("Enter dimension line position")

	end	

	texto = texto +"."

	Sketchup::set_status_text texto

end	

def onMouseMove(flags, x, y, view)

    return false if( !@ip.pick(view, x, y, @ip1) )

	texto_comando

	view.tooltip = @ip.tooltip

	if !@grupo

		@ptfin = @ip.position

		@ptfin.z=@ptini.z

		@ip.pick(view, view.screen_coords(@ptfin).x, view.screen_coords(@ptfin).y) 

		@ptint = @ptfin

	else	

		@ptint = @ptpos if @ptpos

		@ptpos = @ip.position

		@ptpos.z = @ptini.z

		@ip.pick(view, view.screen_coords(@ptpos).x, view.screen_coords(@ptpos).y) 

        pt = @ptpos.project_to_line [@ptini,@ptfin]

		pt = @ptint.project_to_line [pt,@ptpos]	

		@grupo.transform!(Geom::Transformation.translation(@ptpos-pt))

	end if @ptini

	view.invalidate

end

def onLButtonDown(flags, x, y, view)

	@ip1.pick(view,x,y,@ip)

	if !@ptini

		@ptini = @ip.position

		@ptini.z=Sketchup.active_model.active_entities.parent.bounds.min.z if !busca_cara(x, y , view)

	elsif !@grupo

		puntos = intermedios([@ptini,@ptfin],true,true)

		Sketchup.active_model.definitions.load(Sketchup.find_support_file("Indoor_COTAL.skp","Plugins/AF_Indoor"))

		inicioundo(CambiaIdioma("Continuous dimension"))

		@grupo = Sketchup.active_model.active_entities.add_group

		i = 0	

		while i < puntos.size-1 do

			pon_cota_lineal(@grupo,puntos[i],puntos[i+1]) if(puntos[i]-puntos[i+1]).length >= @@cota_minima

			

			i += 1

		end

	else 

		@grupo.explode

		finalundo

		@grupo = false

		reset

	end

	texto_comando

	view.lock_inference

	view.invalidate

end

def onLButtonDoubleClick(flags, x, y, view)

	onLButtonDown(flags, x, y, view)

end

def draw(view)

	textoevaluacion(view)

    if( @ip.valid? && @ip.display? )

        @ip.draw(view)

    end

	view.drawing_color = "black"

	view.line_width = 1 

	inference_locked = view.inference_locked?

	view.set_color_from_line(@ip1, @ip) if @ptini

	if !@grupo 

		view.draw(GL_LINE_STRIP, @ptini, @ptfin)

		puntos = intermedios([@ptini,@ptfin],true,true)

		view.draw_points(puntos,6,2,"red") if puntos.size > 0

		return if puntos.size < 2

		Sketchup::set_status_text  CambiaIdioma("Length"), SB_VCB_LABEL

		vec=puntos.first - puntos.last

		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE

		i = 0		

		i=-1 if Sketchup.version_number <= 8000999

		while i < puntos.size-1 do

			vec = puntos[i]-puntos[i+1]

			view.draw_text(view.screen_coords(punto_medio(puntos[i], puntos[i+1])),vec.length.to_s) if vec.length >= @@cota_minima

			i += 1

		end

	end if @ptini

end

def onUserText(text, view)

	text=con_coma(text,nil)

   begin

        valor = text.to_l

    rescue

        UI.beep

        valor = nil

        Sketchup::set_status_text "", SB_VCB_VALUE

    end

    return if !valor

	@@cota_minima = valor

	texto_comando

	view.invalidate

end

def onKeyDown(key, rpt, flags, view)

	Sketchup::set_status_text CambiaIdioma("Minimun dimension"), SB_VCB_LABEL

end

end

class Indoor_TresDimensiones < Indoor_Base

def texto_comando

	texto = CambiaIdioma("空格=退出当前...")+"."

	Sketchup::set_status_text  texto if @h

end		

def menu

	Sketchup.active_model.selection.add(@grupos)

	prompts = 	[	CambiaIdioma("墙体高度"),

							CambiaIdioma("保留平面")

						]

	grupo = CambiaIdioma("否")

	grupo = CambiaIdioma("是") if !@@crear_grupo					

	defaults = 	[	@@altura_planta.to_l,

							grupo

						]

						

	list = 			[	"",

							CambiaIdioma("是")+"|"+CambiaIdioma("否")

						]

	input = UI.inputbox prompts, defaults, list, CambiaIdioma("生成墙体")

	if input

		h1 = a_longitud(input[0]).abs

		@@altura_planta = h1 if h1>0

		h1 = input[1].to_s.upcase

		@@crear_grupo = (h1 == CambiaIdioma("是"))

	else	

		Sketchup.active_model.select_tool nil	

		return false

	end	

	ejecuta_3d

end

def ponz(ptos, h)

	ptos.each do |pt|		

		pt.z=pt.z+h

	end	

end	

def activate

	@hay_undo=false

	Sketchup.active_model.active_view.invalidate

	@grupos=[]

	Sketchup.active_model.selection.each do |e|

		@grupos.push(e) if e.is_a?(Sketchup::Group)

	end

	if @grupos == []

		UI.messagebox "您必须至少选择一个群组"

		Sketchup.active_model.select_tool(nil)	

		return false

	end	

	seguir=false

	@grupos.each do |g|

		seguir=model_3d(g,true) if !seguir

	end

	if !seguir

	    UI.messagebox "没有项目，无法转换3D模型"

		Sketchup.active_model.select_tool(nil)	

		return false	

	end

	if !@h

		return if !menu

	end	

end

def resume(view)

	view.invalidate

end	

	

def onUserText(text, view)

	text=con_coma(text,nil)

   begin

        valor = text.to_l

    rescue

        UI.beep

        valor = nil

        Sketchup::set_status_text "", SB_VCB_VALUE

    end

    return if !valor

	@@altura_planta = valor

	ejecuta_3d 

end

def ejecuta_3d

	Sketchup.undo if @h

	@h=@@altura_planta

	@h = 3.m if @h<=0

	inicioundo(CambiaIdioma("Convert to 3D")) 

	@grupos.each do |g|

		grupo=g.copy

		altura=g.get_attribute "escalera","2d"

		grupo.set_attribute "escalera","2d",altura if altura

		Sketchup.active_model.active_entities.erase_entities(g) if !@@crear_grupo

		model_3d(grupo, false)

	end

	finalundo 

	texto_comando

end

def model_3d(model,retornar)

	carpinterias = []

	muros = []

	escaleras=[]

	explotar=false

	if model.get_attribute "escalera","2d"

		escaleras.push(model)

		model=Sketchup.active_model.active_entities.add_group(model) if !retornar

		explotar=true

	else		

		model.entities.each do |entidad|

			if	entidad.is_a?(Sketchup::ComponentInstance)	

				if es_carpinteria(entidad)

					carpinterias.push(entidad)

					if carpinterias.size == 1

						$dc_observers.get_latest_class.redraw_with_undo(entidad)

					end	if retornar

				end

			elsif entidad.is_a?(Sketchup::Face)

				esmuro = true

				entidad.edges.each do |e|

					esmuro = false if e.faces.size > 2

					if e.faces.size == 2

						esmuro=false if !(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999)

					end

				end

				muros.push(entidad) if esmuro

			elsif  entidad.get_attribute  "escalera","2d"	

				escaleras.push entidad

			end

		end

	end	

	if carpinterias+muros+escaleras==[]

		return false	

	else

		return true if retornar

	end

	carpinterias.each do |entidad|

		if entidad.definition.name[0,12].upcase == "Indoor_PUERTA"

			hoja2=entidad.get_attribute("dynamic_attributes", "a01hoja2",entidad.definition.get_attribute("dynamic_attributes", "a01hoja2"))

			if hoja2 != 0

				pathcarpinteria = Sketchup.find_support_file("Indoor_PUERTA_DOBLE_3D.skp", "Plugins/AF_Indoor")

			else

				pathcarpinteria = Sketchup.find_support_file("Indoor_PUERTA_3D.skp", "Plugins/AF_Indoor")

			end	

			componente = Sketchup.active_model.definitions.load(pathcarpinteria)

			inicioundo(CambiaIdioma("Convert to 3D"))

			carp = model.entities.add_instance(componente, entidad.transformation)

			v=entidad.get_attribute("dynamic_attributes", "mocheta",entidad.definition.get_attribute("dynamic_attributes", "mocheta"))

			carp.set_attribute("dynamic_attributes", "mocheta", v)

			v=entidad.get_attribute("dynamic_attributes", "a01hoja1",entidad.definition.get_attribute("dynamic_attributes", "a01hoja1"))

			carp.set_attribute("dynamic_attributes", "a01hoja1", v)

			v=entidad.get_attribute("dynamic_attributes", "a01hoja2",entidad.definition.get_attribute("dynamic_attributes", "a01hoja2"))

			carp.set_attribute("dynamic_attributes", "a01hoja2", v)

			v=entidad.get_attribute("dynamic_attributes", "a02dintel",entidad.definition.get_attribute("dynamic_attributes", "a02dintel"))

			carp.set_attribute("dynamic_attributes", "a02dintel", v)

			v=entidad.get_attribute("dynamic_attributes", "a02gruesoh",entidad.definition.get_attribute("dynamic_attributes", "a02gruesoh"))

			carp.set_attribute("dynamic_attributes", "a02gruesoh", v)

			v=entidad.get_attribute("dynamic_attributes", "anchomarco",entidad.definition.get_attribute("dynamic_attributes", "anchomarco"))

			carp.set_attribute("dynamic_attributes", "anchomarco", v)

			v=entidad.get_attribute("dynamic_attributes", "gruesmarco",entidad.definition.get_attribute("dynamic_attributes", "gruesmarco"))

			carp.set_attribute("dynamic_attributes", "gruesmarco", v)

			v=entidad.get_attribute("dynamic_attributes", "a02alineac",entidad.definition.get_attribute("dynamic_attributes", "a02alineac"))

			carp.set_attribute("dynamic_attributes", "a02alineac", v)

			$dc_observers.get_latest_class.redraw(carp)

		elsif entidad.definition.name[0,13].upcase == "Indoor_VENTANA"

			pathcarpinteria = Sketchup.find_support_file("Indoor_VENTANA_3D.skp", "Plugins/AF_Indoor")

			componente = Sketchup.active_model.definitions.load(pathcarpinteria)

			v=(entidad.get_attribute "dynamic_attributes", "a03alfeizar", entidad.definition.get_attribute("dynamic_attributes", "a03alfeizar")).to_f

			if @h>=v-0.03.m

				inicioundo(CambiaIdioma("Convert to 3D"))

				carp = model.entities.add_instance(componente, entidad.transformation)

				carp.set_attribute("dynamic_attributes", "a03alfeizar", v)

				v=entidad.get_attribute("dynamic_attributes", "mocheta",entidad.definition.get_attribute("dynamic_attributes", "mocheta"))

				carp.set_attribute("dynamic_attributes", "mocheta", v)

				v=entidad.get_attribute("dynamic_attributes", "a01ancho",entidad.definition.get_attribute("dynamic_attributes", "a01ancho"))

				carp.set_attribute("dynamic_attributes", "a01ancho", v)

				v=entidad.get_attribute("dynamic_attributes", "a02alto",entidad.definition.get_attribute("dynamic_attributes", "a02alto"))

				carp.set_attribute("dynamic_attributes", "a02alto", v)

				v=entidad.get_attribute("dynamic_attributes", "a02hojas",entidad.definition.get_attribute("dynamic_attributes", "a02hojas"))

				carp.set_attribute("dynamic_attributes", "a02hojas", v)

				v=entidad.get_attribute("dynamic_attributes", "frontalalf",entidad.definition.get_attribute("dynamic_attributes", "frontalalf"))

				carp.set_attribute("dynamic_attributes", "frontalalf", v)

				v=entidad.get_attribute("dynamic_attributes", "carpancho",entidad.definition.get_attribute("dynamic_attributes", "frontalalf"))

				carp.set_attribute("dynamic_attributes", "carpancho", v)

				v=entidad.get_attribute("dynamic_attributes", "carpgrueso",entidad.definition.get_attribute("dynamic_attributes", "carpgrueso"))

				carp.set_attribute("dynamic_attributes", "carpgrueso", v)

				v=entidad.get_attribute("dynamic_attributes", "a02alineac",entidad.definition.get_attribute("dynamic_attributes", "a02alineac"))

				carp.set_attribute("dynamic_attributes", "a02alineac", v)

				$dc_observers.get_latest_class.redraw(carp)

			end	

		elsif entidad.definition.name[0,13].upcase == "Indoor_ARMARIO"

			hojas=(entidad.get_attribute "dynamic_attributes", "a01hojas", entidad.definition.get_attribute("dynamic_attributes", "a01hojas")).to_i

			if hojas == 1

				pathcarpinteria = Sketchup.find_support_file("Indoor_ARMARIO_1_3D.skp", "Plugins/AF_Indoor")

			else

				pathcarpinteria = Sketchup.find_support_file("Indoor_ARMARIO_2_3D.skp", "Plugins/AF_Indoor")

			end	

			componente = Sketchup.active_model.definitions.load(pathcarpinteria)

			v=(entidad.get_attribute "dynamic_attributes", "a01umbral", entidad.definition.get_attribute("dynamic_attributes", "a01umbral")).to_f

			if @h>=v

				inicioundo(CambiaIdioma("Convert to 3D"))

				carp = model.entities.add_instance(componente, entidad.transformation)

				carp.set_attribute("dynamic_attributes", "a01umbral", v)

				v=entidad.get_attribute("dynamic_attributes", "mocheta",entidad.definition.get_attribute("dynamic_attributes", "mocheta"))

				carp.set_attribute("dynamic_attributes", "mocheta", v)

				v=entidad.get_attribute("dynamic_attributes", "a01ancho",entidad.definition.get_attribute("dynamic_attributes", "a01ancho"))

				carp.set_attribute("dynamic_attributes", "a01ancho", v)

				v=entidad.get_attribute("dynamic_attributes", "a02dintel",entidad.definition.get_attribute("dynamic_attributes", "a02dintel"))

				carp.set_attribute("dynamic_attributes", "a02dintel", v)

				carp.set_attribute("dynamic_attributes", "a01hojas", hojas)

				$dc_observers.get_latest_class.redraw(carp)

			end	

		end

	end

	carpinterias.each do |entidad|

		ptos = []

		ptos = muro_carpinteria(entidad) 

		mocheta1 = model.entities.add_line ptos[0], ptos[1]

		mocheta2 = model.entities.add_line ptos[2], ptos[3]

		ptos = tramo_comun(edge_extremos(mocheta1),edge_extremos(mocheta2))

		ptos.push(ptos[1].project_to_line(mocheta2.line))

		ptos.push(ptos[0].project_to_line(mocheta2.line))

		if entidad.definition.name[0,12].upcase == "Indoor_PUERTA"

			v=(entidad.get_attribute "dynamic_attributes", "a02dintel", entidad.definition.get_attribute("dynamic_attributes", "a02dintel")).to_f

			if @h > v

				ponz(ptos,v)

				face = model.entities.add_face(ptos)

				extrusiona(face,@h-v)

			end	

		else

		end

		if entidad.definition.name[0,13].upcase == "Indoor_VENTANA"

			v=(entidad.get_attribute"dynamic_attributes", "a03alfeizar",entidad.definition.get_attribute("dynamic_attributes", "a03alfeizar")).to_f-0.03.m

			if v > 0

				face = model.entities.add_face ptos

				if @h>v

					extrusiona(face,v)

				else

					extrusiona(face,@h)

				end	

			end	

			v = v+(entidad.get_attribute "dynamic_attributes", "a02alto", entidad.definition.get_attribute("dynamic_attributes", "a02alto")).to_f+0.03.m

			if @h > v

				ponz(ptos,v)

				face = model.entities.add_face ptos

				extrusiona(face,@h-v)

			end

		end	

		if entidad.definition.name[0,13].upcase == "Indoor_ARMARIO"

			v=(entidad.get_attribute "dynamic_attributes", "a01umbral", entidad.definition.get_attribute("dynamic_attributes", "a01umbral")).to_f

			if v>0

				face = model.entities.add_face ptos

				if @h>v

					extrusiona(face,v)

				else

					extrusiona(face,@h)

				end

			end

			v =(entidad.get_attribute "dynamic_attributes", "a02dintel", entidad.definition.get_attribute("dynamic_attributes", "a02dintel")).to_f

			if @h > v

				ponz(ptos,v)

				face = model.entities.add_face(ptos)

				extrusiona(face,@h-v)

			end

		end

	end

	model.entities.erase_entities carpinterias	

	muros.each do |entidad|

		face = entidad

		extrusiona(face,@h)

	end	

	borra_coplanarias_3d(model)

	escaleras.each do |escalera|

		escalera.name='escalera'

		escalera_3d(escalera)

	end	

	model.explode if explotar

end	

end

class Indoor_Escalera < Indoor_Base

def initialize

    @ip = Sketchup::InputPoint.new

    @ip1 = Sketchup::InputPoint.new

	@comando_en_curso = "Stair"

end

def menu

	prompts = [	CambiaIdioma("Width"),

						CambiaIdioma("Height"),

						CambiaIdioma("Going"),

						CambiaIdioma("Rise"),

						CambiaIdioma("Slope")

					 ] 

	huella =(@@escalera_huella.to_l).to_s

	huella = '>'+(@@escalera_huellamin.to_l).to_s if @@escalera_huellamin > 0

	tabica =(@@escalera_tabica.to_l).to_s

	tabica = '<'+(@@escalera_tabicamax.to_l).to_s if @@escalera_tabicamax > 0

	defaults = [	@@escalera_width.to_l.to_s,

						@@escalera_height.to_l.to_s,

						huella,

						tabica,

						@@escalera_slope.to_l.to_s

					 ] 

	list = 		[	"",

						"",

						"",

						"",

						""

					 ]				 

	input = UI.inputbox prompts, defaults, list, CambiaIdioma(@comando_en_curso)

	if input

		h1 =a_longitud(input[0]).abs

		@@escalera_width = h1 if h1>0

		h1 = a_longitud(input[1]).abs

		@@escalera_height = h1

		h1 = con_coma(input[2],nil)

		if h1[0].chr == ">"		

			@@escalera_huellamin = h1.split(">")[1].to_l.abs 

		else

			h1=a_longitud(h1).abs

			if h1  > 0

				@@escalera_huella = h1

				@@escalera_huellamin = 0 

			end	

		end	

		h1 = con_coma(input[3],nil)

		if h1[0].chr == "<"		

			@@escalera_tabicamax = h1.split("<")[1].to_l.abs 

		else

			h1=a_longitud(h1).abs

			if h1  > 0

				@@escalera_tabica = h1

				@@escalera_tabicamax = 0 

			end	

		end	

		h1 =a_longitud(input[4]) .abs

		@@escalera_slope = h1

	else	

		Sketchup.active_model.select_tool nil	

		return

	end	

	@huella=@@escalera_huellamin

	@huella=@@escalera_huella if @@escalera_huellamin==0

	huella_tabica

	reset				 

end

def reset

	borra_auxiliares

	@puntos = @total_peld = 0

	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []

    @pts_d = []

	@pts_i = []

	@pts_cursor = []

	@cara_tramo =[]

	@arfin = nil

	@cl1=nil

	@recorrido=false

	@cancelar=false

    Sketchup::set_status_text "", SB_VCB_LABEL

    Sketchup::set_status_text "", SB_VCB_VALUE

    texto_comando

end

def activate

	Sketchup.active_model.active_view.invalidate

    menu

end

def texto_comando

	texto = CambiaIdioma("Stair") 

	if !@recorrido

		texto= texto+"["+ @@escalera_width.to_l.to_s+'].'

	else

		texto= texto+"["+ CambiaIdioma("Path")+'].'

	end

	if @puntos == 0

		texto = texto+CambiaIdioma("Starting point")+"("+ CambiaIdioma("Dbl_Click for Path")+")"

	else	

		texto= texto+CambiaIdioma("End point")

		texto = texto + ", " + CambiaIdioma("or specify width preceded by") + " '-'" if !@recorrido

	end	

	texto = texto+"."

	if @puntos>0

		texto = texto + " Tab="

		texto = texto + " Ctrl="

		texto=texto + CambiaIdioma("Change edge")+"." 	

		texto=texto+" Ctrl="

		texto=texto+" Option="

		texto = texto +CambiaIdioma("Force")+"."

	end if !@recorrido

	Sketchup::set_status_text  texto 

end		

def deactivate(view)

	view.invalidate

	reset

end

def onSetCursor

	UI.set_cursor(@@escaleracursor_id)

end

def auxiliares(punto)

	borra_auxiliares

	inicioundo('Tramo de escalera')

	crea_auxiliares(punto)

	finalundo

end

def borra_auxiliares

	if !@cl1.deleted?

		Sketchup.undo

	end if @cl1

end	

def calcula_puntos

	if(@puntos == 0) then 

 		@ptini = @ip.position

    else

		if @puntos > 1 

			vertice1=@ptini.project_to_line [@pts_i[@puntos-1],@pts_i[@puntos-2]]

			vertice2=@ptini.project_to_line [@pts_d[@puntos-1],@pts_d[@puntos-2]]

			vec =(vertice1 - vertice2)

			@ptini = vertice1.offset(vec, -@@escalera_cara*vec.length)

		end	

 		if @@escalera_cara > 0 then

			vec = @ptini - [@ptini[0] +(@ptfin[1] - @ptini[1]), @ptini[1] - (@ptfin[0] - @ptini[0]),@ptini[2]]

			return if vec.length == 0

			@pt1 = @ptini.offset(vec, @@escalera_cara * @@escalera_width)	 

			@pt2 = @ptfin.offset(vec, @@escalera_cara * @@escalera_width)

		else

			@pt1 = @ptini	 

			@pt2 = @ptfin	   

		end

		vec = @ptini - [@ptini[0] - (@ptfin[1] - @ptini[1]), @ptini[1] +(@ptfin[0] - @ptini[0]),@ptini[2]]

		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE

		if vec.length > 0

			@pt3 = @pt1.offset(vec, @@escalera_width)	 

			@pt4 = @pt2.offset(vec, @@escalera_width)	   

		end	

		if(@puntos > 1) 

			if !((@pt3- @pt4).parallel?(@pts_d[@puntos-2]-@pts_d[@puntos-1]))

				vec =(@pts_d[@puntos-2]-@pts_d[@puntos-1])

				vec =(@pts_i[@puntos-2]-@pts_i[@puntos-1]) if vec.length < 0.000001

				@pt3 = Geom.intersect_line_line([@pt3, @pt4], [@pts_d[@puntos-2], vec])

				@pt1 = Geom.intersect_line_line([@pt1, @pt2], [@pts_i[@puntos-2], vec])

			end if ((@pt3- @pt4).length >0) && ((@pts_d[@puntos-2]-@pts_d[@puntos-1]).length >0)

		end

	end

end

def onMouseMove(flags, x, y, view)

    return false if(!@ip.pick(view, x, y, @ip1))

	texto_comando

    view.tooltip = @ip.tooltip

	@ptfin=@ip.position

	@ptfin.z=@ptini.z if @ptini!=[]

    calcula_puntos

	view.invalidate

	@arfin = busca_cara(x, y, view)

end

def tramo_escalera

	@pt_final_i=@pt_rest_i

	@pt_final_d=@pt_rest_d

	@pts_cursor[@puntos] = @ptini

	@ptini = @ptfin

	@pts_i[@puntos] = @pt2

	@pts_d[@puntos-1] = @pt3

	@pts_d[@puntos] = @pt4

	@pts_i[@puntos-1] = @pt1

	@cara_tramo[@puntos] = @@escalera_cara

end

def escalones(linea)

	lineas_ini = []

	puntos =[]

	Sketchup.active_model.active_entities.each do |e|

		if e.is_a?(Sketchup::Edge)

			pt=interseccion_real(linea[0], linea[1], e.start.position, e.end.position)

			if pt

				puntos.push pt

				lineas_ini.push e

			end

		end	

	end		

	i = -1

	ultimadistancia=-1

	lineas_ordenadas=[] 

	while i < puntos.size-1 do

		j = 0

		k = 0

		distancia = 1000000.0

		while j < puntos.size

			if puntos[j] 

				if(linea[0]-puntos[j]).length < distancia

					distancia =(linea[0]-puntos[j]).length

					linea_mas_cerca = lineas_ini[j]

					k = j

				end	

			end 

			j += 1

		end

		lineas_ordenadas.push(linea_mas_cerca) if distancia > ultimadistancia

		ultimadistancia=distancia

		puntos[k] = nil

		i += 1

	end	

	caras=[]

	lineas_ordenadas.each do |e|		

		if e.faces.size == 2 ||(e.faces.size ==1 && caras.size==0 && @huellas_recorrido.size==0)

			normales=0

			e.faces.each do |f|

				normales=normales+f.normal.z.abs

			end

			if normales>0.999999+e.faces.size-1

				e.faces.each do |f|

					caras.push f if f != @ultima_huella

				end

				@ultima_huella=caras[caras.size-1]

			end	

		end 

	end	

	return caras

end

def onLButtonDown(flags, x, y, view)

	@ip1.pick(view,x,y,@ip)

	if @puntos == 0 then

		@pts_i[@puntos] = @ip.position

		@pts_cursor[@puntos] = @ip.position

	else

		@ptfin=@ptescalon if !@pulsado_control  && !@recorrido

		calcula_puntos

		tramo_escalera

	end

	@puntos +=1

	auxiliares(@ptini)

	texto_comando

end

def onRButtonDown(flags, x, y, view)

	ejecuta_escalera

end	

def onLButtonDoubleClick(flags, x, y, view)

	if @puntos==1 

		@recorrido=true

	else	

		ejecuta_escalera

	end	

	texto_comando

	view.invalidate

end	

def ejecuta_escalera

	borra_auxiliares

	inicioundo(@comando_en_curso)

	if @recorrido

		escalera_recorrido 

	else

		escalera_generada

	end	

	finalundo

	Sketchup.active_model.select_tool nil

end

def escalera_recorrido

	escalera2=Sketchup.active_model.active_entities.add_group

	huellas=@huellas_final

	peld=0

	huellas.each do |face|

		peld+=1

		face.set_attribute "escalera","escalon",peld*@tabica

		face.reverse! if face.normal.z<0

	end

	escalera2=Sketchup.active_model.active_entities.add_group(huellas)

	escalera2.set_attribute "escalera","2d",peld*@tabica

end

def escalera_generada

	escalera = Sketchup.active_model.active_entities.add_group

	escalera2=Sketchup.active_model.active_entities.add_group

	punto=nil

	peld=0

	@pts_i[@puntos-1]=@pt_final_i

	@pts_d[@puntos-1]=@pt_final_d

	for i in 1 ... @puntos

		temp=[@pts_i[i-1], @pts_i[i], @pts_d[i], @pts_d[i-1]]

		ptos=[temp[0]]

		for j in 1 ... temp.size

			ptos.push(temp[j]) if ptos[ptos.size-1]!=temp[j]

		end

		face=escalera.entities.add_face ptos

		if punto

			edges=face.edges

			edges.each do |e|

				escalera.entities.erase_entities e if e.faces.size==2 && !punto_en_segmento(punto, e.start.position, e.end.position)

			end			

		end		

		ht=huellas_tramo([@pts_i[i-1],@pts_i[i]],[@pts_d[i-1],@pts_d[i]], punto)

		if ht

			1.step(ht.size-1,2) do |j|

				escalera.entities.add_line ht[j-1],ht[j]

			end	

			punto=punto_medio(ht[ht.size-2],ht[ht.size-1])

		end	if @pts_i[i-1]!=@pts_i[i] && @pts_d[i-1] != @pts_d[i]	

		escalera.entities.add_line @pts_i[i-1],@pts_i[i]

		escalera.entities.add_line @pts_d[i-1],@pts_d[i]

		huellas=[]

		escalera.entities.each do |e|

			huellas.push e if e.is_a?(Sketchup::Face)

		end

		for j in 0..huellas.size-2

			e=huellas[j]

			vert=[]

			e.vertices.each do |v|

				vert.push v.position

			end	

			peld+=1

			face=escalera2.entities.add_face vert

			face.set_attribute "escalera","escalon",peld*@tabica

			face.reverse! if face.normal.z<0

		end

		e=huellas[huellas.size-1]

		vert=[]

		e.vertices.each do |v|

			vert.push v.position

		end

		Sketchup.active_model.active_entities.erase_entities escalera

		escalera=Sketchup.active_model.active_entities.add_group

		escalera.entities.add_face vert

	end	

	peld+=1

	face=escalera2.entities.add_face vert

	face.set_attribute "escalera","escalon",peld*@tabica

	face.reverse! if face.normal.z<0

	Sketchup.active_model.active_entities.erase_entities escalera

	escalera2.set_attribute "escalera","2d",peld*@tabica

end

def onCancel(flag, view)

	@cancelar=true

	if @puntos==1

		view.lock_inference if( view.inference_locked? )

		reset

	end	

end

def longitud_usuario(value, view)

	

end

def onUserText(text, view)

	valores = text.split("<")

	if valores[1]

		angulo = valores[1].to_f.degrees

		@@hv = [Math.cos(angulo), Math.sin(angulo)]

		auxiliares(@ptini) if @puntos > 0

		return

	end

	valores=valores[0].split(@@separador_listas)

	if valores[1]

		valores2 = valores[1].split('>')

		if valores2[1]

			l=long_valida(valores2[1]).abs

			@@escalera_huellamin = l if l

		else

			l=long_valida(valores2[0]).abs

			if l

				@@escalera_huella=l

				@@escalera_huellamin=0

			end

		end

		huella_tabica

	end

	valores = valores[0].split'*'

	if valores[1]

		l=valores[1].to_i

		value=@primer_peld+l*@huella+0.000001

	else

		value=long_valida(valores[0])

	end	

	if value

		if value < 0 then

			@@escalera_width = value.abs.to_l

			texto_comando

			calcula_puntos

		elsif @puntos > 0 && value>0

			vec = @ptfin - @ptini

			if( vec.length > 0.0 )

				vec.length = value

				@ptfin = @ptini.offset(vec)

				calcula_puntos

				tramo_escalera

				@puntos +=1

			end	

		end

	end

	auxiliares(@ptini)

	texto_comando

	view.invalidate

 end

 

def huella_tabica

	return if !@huella

	@huella=0 if @huella.to_s=='NaN'

	if @huella==0

		@huella=@@escalera_huellamin

		@huella=@@escalera_huella if @huella==0

	end

	if @@escalera_tabicamax > 0

		@tabica=1000000.0 

		@tabica=(@@escalera_slope-@huella)/2  if @@escalera_slope>0

		@tabica=@@escalera_tabicamax if @tabica>@@escalera_tabicamax

	else

		@tabica=@@escalera_tabica

	end	

	if @@escalera_height>0

		n=((@@escalera_height/@tabica)).to_i

		@tabica=@@escalera_height/n

		tabicamax=@@escalera_tabicamax

		tabicamax=@@escalera_tabica if tabicamax==0

		while @tabica>tabicamax

			n+=1

			@tabica=@@escalera_height/n

		end	

		@total_peld=n

	end	

	if @@escalera_huellamin>0

		@huella=@@escalera_slope-(2*@tabica)

		while @huella<@@escalera_huellamin

			n+=1

			@tabica=@@escalera_height/n

			@huella=@@escalera_slope-(2*@tabica)

		end if @@escalera_height > 0	

	end  if @@escalera_slope > 0

end

def huellas_tramo(lineai, linead, punto)

	huellas=[]

	extremos =tramo_comun(lineai, linead)

	return nil if extremos == []

	tramo =(extremos[0]-extremos[1])

	return nil if tramo.length < 0.000001

	peld1 = [extremos[0],extremos[0].project_to_line(linead)]

	dist = punto.distance_to_line peld1 if punto

	

	if dist<@huella

		if punto_en_segmento(punto.project_to_line(peld1), peld1[0], peld1[1])

			extremos[0]=punto_a_distancia(extremos[0],extremos[1],@huella-dist)

		end		

	end if dist

	return if !extremos[1] || !extremos[0]

	if(extremos[1]-lineai[0]).length <(extremos[0]-lineai[0]).length 

		@primer_peld=0.0

		return

	end	

	tramo =(extremos[0]-extremos[1])

	if @huella==0

		@huella=tramo.length/((tramo.length/@@escalera_huellamin).to_i)

		huella_tabica

	end	

	n=(tramo.length/@huella).to_i

	for i in 0 .. n

		pt1=punto_a_distancia(extremos[0],extremos[1],i*@huella) 

		huellas.push(pt1)

		huellas.push(pt1.project_to_line(linead))

	end

	return huellas

end

def texto_descansillo(view, punto, peld_tramo, peld)

	return if !punto

	view.draw_text(view.screen_coords(punto), peld.to_s+'/'+(peld*@tabica).to_l.to_s) if peld_tramo > 0	

end	

def draw(view)

	return if !@huella

	textoevaluacion(view)

	x=view.corner(0)[0]

	y=view.corner(0)[1]

	if !@recorrido

		view.draw_text([x+5,y+25],CambiaIdioma(@comando_en_curso))

		huella_tabica

		view.draw_text([x+5,y+40],CambiaIdioma("Going")+':'+@huella.to_l.to_s)

		view.draw_text([x+5,y+55],CambiaIdioma("Rise")+':'+@tabica.to_l.to_s)

		view.draw_text([x+5,y+70],CambiaIdioma("Slope")+':'+(2*@tabica+@huella).to_l.to_s)

	end	

	if @cl1.deleted? && @cancelar

		@cancelar=false if @puntos>1

		@puntos -=1

		@@escalera_cara = @cara_tramo[@puntos]

		@ptini = @pts_cursor[@puntos]

		auxiliares(@ptini)

		calcula_puntos

	elsif @cancelar

		ejecuta_escalera

		return

	end if @cl1

	reset if @cancelar

    @ip.draw(view) if( @ip.valid? && @ip.display? )

    view.drawing_color = "black"

    inference_locked = view.inference_locked?

	peld=0

	if @recorrido && @puntos>0

		if @@escalera_height>0

			if @huellas_recorrido

				@tabica=@@escalera_height/@huellas_recorrido.size if @huellas_recorrido.size>0

			end	

		end

		@ultima_huella=nil

		@huellas_recorrido=[]

		if @puntos>1

			view.draw(GL_LINE_STRIP, @pts_cursor[0..@puntos-1])

			view.draw(GL_LINE_STRIP, @pts_cursor[@puntos-1],@ptini)

		end

		if @puntos > 1

			for i in 1...@puntos

				h=escalones([@pts_cursor[i-1],@pts_cursor[i]])

				@huellas_recorrido=@huellas_recorrido+h

				peld_tramo=h.size

				peld +=peld_tramo

				pt_texto=@pts_cursor[i]

				texto_descansillo(view,pt_texto, peld_tramo,peld)

			end 

			h=escalones([@pts_cursor[@puntos-1],@ptini])

			@huellas_recorrido=@huellas_recorrido+h

			peld_tramo=h.size

			peld +=peld_tramo

			pt_texto=@ptini

			texto_descansillo(view,pt_texto, peld_tramo,peld)

		end 

		@huellas_final=@huellas_recorrido

		view.draw(GL_LINE_STRIP, @ptini, @ptfin)

		h=escalones([@ptini,@ptfin])

		@huellas_recorrido=@huellas_recorrido+h

		peld_tramo=h.size

		peld+=peld_tramo

		pt_texto=@ptfin

		texto_descansillo(view,pt_texto, peld_tramo,peld)

		return

	end

	@huella=@@escalera_huella

	@huella=0.0 if @@escalera_huellamin > 0

	punto = nil

	peld_tramo=0

    if @puntos > 1 then

		if @puntos >2

			view.draw(GL_LINE_STRIP, @pts_i[0..@puntos-2])

			view.draw(GL_LINE_STRIP, @pts_d[0..@puntos-2])

			for i in 1..@puntos-2 

				ht=huellas_tramo([@pts_i[i-1],@pts_i[i]],[@pts_d[i-1],@pts_d[i]], punto)

				if ht

					peld_tramo=ht.size/2

					peld=peld+peld_tramo

					view.draw(GL_LINES, ht)

					punto=punto_medio(ht[ht.size-2],ht[ht.size-1])

					texto_descansillo(view,punto, peld_tramo,peld)

				end	if @pts_i[i-1]!=@pts_i[i] && @pts_d[i-1] != @pts_d[i]

			end	

		end

		if @ptini != @ptfin	

			view.draw(GL_LINE_STRIP, @pts_i[@puntos-2], @pt1)

			view.draw(GL_LINE_STRIP, @pts_d[@puntos-2], @pt3)

			ht=huellas_tramo([@pts_i[@puntos-2], @pt1],[@pts_d[@puntos-2], @pt3], punto)

			if ht

				peld_tramo=ht.size/2

				peld=peld+peld_tramo

				punto=punto_medio(ht[ht.size-2],ht[ht.size-1])

				texto_descansillo(view,punto, peld_tramo,peld)

				view.draw(GL_LINES, ht)

			end	

		end

	end	

 	view.set_color_from_line(@ip1, @ip) if @puntos>0

	ht = huellas_tramo([@pt1, @pt2],[@pt3, @pt4], punto) if (@pt1 != @pt2 && @pt3 != @pt4)

	if ht.size > 0

		pt = @ptini.project_to_line [ht[0],ht[1]]

		@primer_peld=(@ptini-pt).length

		peld_tramo=ht.size/2

		peld=peld+peld_tramo

		pt_texto=punto_medio(ht[ht.size-2],ht[ht.size-1])

	end if ht

	texto_descansillo(view,pt_texto, peld_tramo,peld)

	view.draw(GL_LINES,ht) if ht

	view.line_width = 3 if inference_locked

	view.draw(GL_LINE_STRIP, @pt1, @pt2) if @pt1 !=[]  && @pt2 !=[]

    view.draw(GL_LINE_STRIP, @pt3, @pt4) if @pt3 !=[]  && @pt3 !=[]

    view.line_width = 1 if inference_locked

	return if !ht

	pt = @ptfin.project_to_line [ht[ht.size-2],ht[ht.size-1]]

	vec=@ptfin-pt

	dist_peld=vec.length

	return if vec.length == 0

	vec.length=0.000001

	@ptescalon=pt.offset(vec)

	vec=(@ptfin-@ptini)

	value=@huella+0.000001

	return if vec.length == 0

	vec.length = value-dist_peld

	@pt_rest_i = @pt2.offset(vec)

	@pt_rest_d = @pt4.offset(vec)

	if peld<@total_peld+1

		resto=@total_peld-peld+1

	else

		resto=1

	end

	value=resto*@huella+0.000001

	return if vec.length == 0

	vec.length = value-dist_peld

	pt_rest_1 = @pt2.offset(vec)

	pt_rest_2 = @pt4.offset(vec)

	ht = huellas_tramo([@pt2, pt_rest_1],[@pt4, pt_rest_2], pt_texto)

	view.drawing_color = "red"

	view.draw(GL_LINES,ht)

	view.draw(GL_LINE_STRIP, @pt2, pt_rest_1)

	view.draw(GL_LINE_STRIP, @pt4, pt_rest_2)

end

def tabulador

	return if @recorrido

	if @@escalera_inc then

		@@escalera_cara += 0.5

	elsif

		@@escalera_cara -= 0.5

	end	

	@@escalera_inc = !@@escalera_inc if @@escalera_cara != 0.5

end

def onKeyDown(key, rpt, flags, view)

	if(key == 9) ||(key==VK_CONTROL) then

		tabulador

		calcula_puntos

		auxiliares(@ptini)

		view.invalidate

	elsif key == 119

		lb = @arfin.line 

		if lb

			@@hv = [lb[1][0],lb[1][1]]

			auxiliares(@ptini) if @puntos > 0

		end

	elsif( key == CONSTRAIN_MODIFIER_KEY && rpt == 1 )

        if( view.inference_locked? )

            view.lock_inference

        elsif !@primer_punto

            view.lock_inference @ip

        elsif

            view.lock_inference @ip, @ip1

		end

	elsif(key == COPY_MODIFIER_KEY)

		@pulsado_control = true

	end	

end

def onKeyUp(key, rpt, flags, view)

	if(key == CONSTRAIN_MODIFIER_KEY && view.inference_locked?)

		view.lock_inference

	elsif(key == COPY_MODIFIER_KEY)

		@pulsado_control=false

    end

end

end

class Indoor_Preferencias < Indoor_Base

def texto_comando

	Sketchup::set_status_text(CambiaIdioma("Select language"))

end

def menu

	path =(Sketchup.find_support_file("Indoor_cmd.rbs",  "plugins/AF_Indoor"+"/")).to_s

	path=path [0 .. path.length-15]

	path=path + '/resources'

	lenguajes = []

	Dir.foreach(path) { |f|

		lenguajes.push(f.to_s) if f.to_s != '.' && f.to_s !='..'

	}

	

	prompts=[]

	prompts = 	[	CambiaIdioma("Language")+":"

						]

						

	defaults = 	[	CambiaIdioma(Sketchup.read_default("Indoor","Language",Sketchup.get_locale[0,2]))

					]

	lista=""

	lenguajes.each do |l|

		lista=lista+CambiaIdioma(l)+"|"

	end	

	list=[lista]

	input = UI.inputbox prompts, defaults, list,CambiaIdioma("Indoor for Sketchup")+": "+CambiaIdioma("Options")

	if input

		lista=lista.split("|")

		i=0

		i += 1 while lista[i] != input[0]

		Sketchup.write_default("Indoor","Language",lenguajes[i])

		IndoorStrings.ParseLangFile

		cambia_idioma_comandos

	end

	Sketchup.active_model.select_tool nil	

end

def cambia_idioma_comandos

	@@murocmd.tooltip = CambiaIdioma("Wall")  

	@@murocmd.status_bar_text = CambiaIdioma("Draw walls from point to point.")

	@@muropcmd.tooltip = CambiaIdioma("Paralell wall")

	@@muropcmd.status_bar_text = CambiaIdioma("Draw walls parallel to a edge.")

	@@Estiramurocmd.tooltip = CambiaIdioma("Extend wall")

	@@Estiramurocmd.status_bar_text = CambiaIdioma("Extend / shorten walls.")

	@@puertacmd.tooltip = CambiaIdioma("Door")

	@@puertacmd.status_bar_text = CambiaIdioma("Place doors in walls.")

	@@ventanacmd.tooltip = CambiaIdioma("Window")

	@@ventanacmd.status_bar_text = CambiaIdioma("Place windows in walls.")

	@@armariocmd.tooltip = CambiaIdioma("Wardrobe")

	@@armariocmd.status_bar_text = CambiaIdioma("Place wardrobes in walls.")

	@@escaleracmd.tooltip = CambiaIdioma("Stair")

	@@escaleracmd.status_bar_text = CambiaIdioma("Draw stairs from point to point or by path.")

	@@cotacontinuacmd.tooltip = CambiaIdioma("Continuous dimension")

	@@cotacontinuacmd.status_bar_text = CambiaIdioma("Continuous interior dimensions between two points.")

	@@tresdcmd.tooltip = CambiaIdioma("Convert to 3D")	

	@@tresdcmd.status_bar_text = CambiaIdioma("Transforms the 2D model into a 3D model with height defined.")

	@@preferenciascmd.tooltip = CambiaIdioma("Options")

	@@preferenciascmd.status_bar_text = CambiaIdioma("Select language")

end

	

end

Sketchup.extensions.each{|e| AF_Indoor=e if e.name=='Indoor'}

IndoorStrings = Indoor_Lenguaje.new

IndoorLicencia = Indoor_Licencia.new

IndoorHoraInicio = Time.now

Indoor_Inicio.new


